// Copyright: "Copyright (c) 1984, 1987 Adobe Systems Incorporated. All Rights Reserved. Copyright (c) 1988, 1991 Digital Equipment Corporation. All Rights Reserved."

// ISO10646-1 extension by Markus Kuhn <mkuhn@acm.org>, 2001-03-20
// 
// +
//  Copyright 1984-1989, 1994 Adobe Systems Incorporated.
//  Copyright 1988, 1994 Digital Equipment Corporation.
// 
//  Adobe is a trademark of Adobe Systems Incorporated which may be
//  registered in certain jurisdictions.
//  Permission to use these trademarks is hereby granted only in
//  association with the images described in this file.
// 
//  Permission to use, copy, modify, distribute and sell this software
//  and its documentation for any purpose and without fee is hereby
//  granted, provided that the above copyright notices appear in all
//  copies and that both those copyright notices and this permission
//  notice appear in supporting documentation, and that the names of
//  Adobe Systems and Digital Equipment Corporation not be used in
//  advertising or publicity pertaining to distribution of the software
//  without specific, written prior permission.  Adobe Systems and
//  Digital Equipment Corporation make no representations about the
//  suitability of this software for any purpose.  It is provided "as
//  is" without express or implied warranty.
// -

/// Bitmaps for the sans_10 font

// Autogenerated by convertfont.toit from the BDF file third_party/x11/xorg-adobe-100dpi/helvR10.bdf

/**
The characters from the ASCII Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Basic_Latin_(Unicode_block) )
This block has 95 assigned code points, and they are all
  present in this font.
  This block contains characters in the range 0x0000-0x007f.
  The bitmaps for this block in this font take up about 1588 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
ASCII ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0x34, 0x6, 0x0, 0x0, // Length 1588.
  0xf4, 0x57, 0x22, 0x24, 0x75, 0x6b, 0x16, 0xd5, 0x89, 0x8e, 0x35, 0x5c, 0x4e, 0xfb, 0x71, 0x8e, 0x28, 0x21, 0xae, 0x84, 0x91, 0x35, 0x62, 0x49, 0x6b, 0x62, 0x2, 0x79, 0x5b, 0xd8, 0x2, 0xbe, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x0, 0x0, 0x0, // Unicode range start 0x000000.
  116, 0x7f, 0x0, 0x0, // Unicode range end 0x00007f.
  0,
  4, 1, 0, 0, 0, // 0020 space
  32, 0,
  4, 1, 11, 2, 0, // 0021 exclam
  33, 3, 0xba, 0x3e, 0xb9,
  5, 3, 3, 1, 8, // 0022 quotedbl
  34, 2, 0x28, 0x14,
  8, 7, 10, 0, 0, // 0023 numbersign
  35, 8, 0x5, 0x14, 0x7e, 0xa, 0x13, 0xf0, 0x50, 0x50,
  8, 7, 14, 0, 254, // 0024 dollar
  36, 15, 0x4, 0x7, 0xc2, 0x49, 0x24, 0x5, 0x0, 0xe0, 0x14, 0x4, 0x89, 0x24, 0x7c, 0x4, 0x10,
  12, 11, 11, 0, 0, // 0025 percent
  37, 16, 0x1c, 0x2e, 0x22, 0x79, 0x47, 0x24, 0x2, 0x71, 0xc4, 0x9, 0x30, 0x30, 0x20, 0x50, 0x84, 0xc0,
  10, 8, 10, 1, 0, // 0026 ampersand
  38, 11, 0xc, 0x4, 0x84, 0x30, 0xf4, 0x52, 0x22, 0x88, 0x42, 0x28, 0x71,
  3, 1, 3, 1, 8, // 0027 quotesingle
  39, 2, 0xb9, 0x40,
  5, 3, 14, 1, 253, // 0028 parenleft
  40, 5, 0x8, 0x31, 0xc8, 0xe9, 0xa0,
  5, 3, 14, 1, 253, // 0029 parenright
  41, 4, 0xba, 0x9a, 0x8f, 0x1c,
  7, 5, 5, 1, 6, // 002a asterisk
  42, 7, 0x8, 0xa, 0x81, 0xc0, 0xa8, 0x8, 0x0,
  9, 7, 7, 1, 1, // 002b plus
  43, 5, 0x4, 0x14, 0xfe, 0x4, 0x14,
  3, 2, 4, 0, 254, // 002c comma
  44, 3, 0x10, 0x17, 0x0,
  4, 3, 1, 0, 4, // 002d hyphen
  45, 2, 0x38, 0x0,
  3, 1, 2, 1, 0, // 002e period
  46, 1, 0xb9,
  4, 4, 11, 0, 0, // 002f slash
  47, 5, 0x4, 0x1c, 0x5c, 0x5c, 0x50,
  8, 6, 11, 1, 0, // 0030 zero
  48, 5, 0x1e, 0x8, 0x48, 0xd1, 0xe0,
  8, 3, 11, 2, 0, // 0031 one
  49, 5, 0x8, 0xe, 0x0, 0x82, 0x34,
  8, 6, 11, 1, 0, // 0032 two
  50, 8, 0x1e, 0x8, 0x44, 0x4, 0xcc, 0xcc, 0xc4, 0xfc,
  8, 6, 11, 1, 0, // 0033 three
  51, 10, 0x1e, 0x8, 0x44, 0x4, 0x43, 0x80, 0x11, 0x21, 0x11, 0xe0,
  8, 7, 11, 1, 0, // 0034 four
  52, 10, 0x1, 0x34, 0x14, 0x9, 0x4, 0x42, 0x11, 0x3f, 0x80, 0x45,
  8, 6, 11, 1, 0, // 0035 five
  53, 9, 0x3f, 0x2e, 0x53, 0xe0, 0x4, 0x52, 0x11, 0x1e, 0x0,
  8, 6, 11, 1, 0, // 0036 six
  54, 10, 0x1e, 0x8, 0x4b, 0x92, 0xe0, 0xc4, 0x21, 0x15, 0x1e, 0x0,
  8, 6, 11, 1, 0, // 0037 seven
  55, 6, 0x3f, 0x0, 0x4c, 0x71, 0xc7, 0x14,
  8, 6, 11, 1, 0, // 0038 eight
  56, 8, 0x1e, 0x8, 0x45, 0x47, 0x82, 0x11, 0x51, 0xe0,
  8, 6, 11, 1, 0, // 0039 nine
  57, 9, 0x1e, 0x8, 0x45, 0x47, 0xc0, 0x11, 0x21, 0x11, 0xe0,
  3, 1, 8, 1, 0, // 003a colon
  58, 4, 0xb9, 0xe5, 0x6e, 0x40,
  4, 2, 10, 0, 254, // 003b semicolon
  59, 5, 0x10, 0x1e, 0x54, 0x40, 0x5c,
  8, 6, 5, 1, 2, // 003c less
  60, 7, 0x3, 0x3, 0x3, 0x0, 0x30, 0x3, 0x0,
  9, 6, 3, 1, 3, // 003d equal
  61, 3, 0x3f, 0x38, 0xfc,
  8, 6, 5, 1, 2, // 003e greater
  62, 7, 0x30, 0x3, 0x0, 0x30, 0x30, 0x30, 0x0,
  8, 6, 11, 1, 0, // 003f question
  63, 9, 0xc, 0xc, 0xc2, 0x11, 0x1, 0x33, 0x33, 0x82, 0x4,
  13, 11, 12, 1, 255, // 0040 at
  64, 22, 0x3, 0xd0, 0xc0, 0xc0, 0x10, 0x2, 0x1, 0x18, 0xa0, 0x22, 0x42, 0x2, 0x45, 0x52, 0x4f, 0x8, 0xdc, 0x10, 0x3a, 0x6e, 0x7, 0xf8,
  9, 9, 11, 0, 0, // 0041 A
  65, 13, 0x2, 0x1b, 0xd0, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5,
  9, 7, 11, 1, 0, // 0042 B
  66, 11, 0x3f, 0x8, 0x62, 0x9, 0x21, 0xf, 0x82, 0x10, 0x82, 0x74, 0xfc,
  10, 8, 11, 1, 0, // 0043 C
  67, 9, 0x7, 0x6, 0x31, 0x6, 0xe8, 0x4, 0x11, 0x8c, 0x1c,
  10, 8, 11, 1, 0, // 0044 D
  68, 9, 0x3e, 0x8, 0x62, 0x8, 0x81, 0x80, 0x82, 0xd3, 0xe0,
  9, 7, 11, 1, 0, // 0045 E
  69, 7, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8,
  8, 7, 11, 1, 0, // 0046 F
  70, 6, 0x3f, 0xae, 0x54, 0xfc, 0xba, 0x0,
  11, 9, 11, 1, 0, // 0047 G
  71, 14, 0x7, 0x91, 0x86, 0xef, 0x5c, 0xe5, 0x21, 0xee, 0xb9, 0x5a, 0x46, 0x34, 0x1c, 0x40,
  10, 8, 11, 1, 0, // 0048 H
  72, 5, 0x20, 0x60, 0xfc, 0x81, 0x80,
  4, 1, 11, 2, 0, // 0049 I
  73, 2, 0xba, 0xc0,
  7, 6, 11, 0, 0, // 004a J
  74, 5, 0x1, 0x23, 0x21, 0x11, 0xe0,
  9, 8, 11, 1, 0, // 004b K
  75, 13, 0x20, 0x88, 0x42, 0x20, 0x90, 0x28, 0x34, 0x90, 0x22, 0x8, 0x42, 0x8, 0x81,
  8, 6, 11, 2, 0, // 004c L
  76, 4, 0xba, 0x35, 0x3f, 0x0,
  12, 11, 11, 0, 0, // 004d M
  77, 14, 0xb8, 0x20, 0x9d, 0x52, 0x80, 0xa0, 0x52, 0x44, 0x20, 0x52, 0x29, 0x52, 0x11, 0x50,
  10, 8, 11, 1, 0, // 004e N
  78, 9, 0x30, 0x4a, 0x14, 0x91, 0x48, 0x94, 0x85, 0x48, 0x34,
  11, 9, 11, 1, 0, // 004f O
  79, 12, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x8d, 0x10, 0x78, 0x63, 0x41, 0xc4,
  9, 7, 11, 1, 0, // 0050 P
  80, 8, 0x3f, 0x8, 0x62, 0x9, 0xd3, 0xf2, 0xe8, 0x0,
  11, 9, 11, 1, 0, // 0051 Q
  81, 15, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x80, 0x88, 0x48, 0x44, 0x43, 0xe9, 0x41, 0xcb, 0x80,
  10, 8, 11, 1, 0, // 0052 R
  82, 10, 0x3f, 0x88, 0x32, 0x5, 0x20, 0x8f, 0xc2, 0x8, 0x81, 0x54,
  9, 7, 11, 1, 0, // 0053 S
  83, 13, 0xe, 0xc, 0x62, 0xa, 0xe1, 0x80, 0x18, 0x1, 0xbc, 0x20, 0x8c, 0x60, 0xe0,
  9, 9, 11, 0, 0, // 0054 T
  84, 5, 0xfe, 0xe0, 0x23, 0xac, 0x80,
  10, 8, 11, 1, 0, // 0055 U
  85, 5, 0x20, 0x63, 0x44, 0x20, 0xf0,
  9, 9, 11, 0, 0, // 0056 V
  86, 12, 0xba, 0xe5, 0x10, 0x79, 0x46, 0x34, 0x22, 0x54, 0x14, 0x57, 0xe5, 0x40,
  13, 13, 11, 0, 0, // 0057 W
  87, 12, 0x20, 0x80, 0x85, 0x21, 0x51, 0x17, 0x20, 0xa, 0xa, 0x8, 0x3e, 0xc5,
  9, 9, 11, 0, 0, // 0058 X
  88, 15, 0xba, 0xe1, 0x7, 0x82, 0x24, 0x14, 0x7e, 0x54, 0x14, 0x42, 0x24, 0x41, 0x56, 0xeb, 0x80,
  9, 9, 11, 0, 0, // 0059 Y
  89, 12, 0xba, 0xe3, 0x5, 0x10, 0x78, 0x22, 0x54, 0x14, 0x41, 0xc7, 0xe8, 0xc0,
  9, 7, 11, 1, 0, // 005a Z
  90, 9, 0x3f, 0x80, 0x2c, 0xcd, 0xf7, 0x37, 0xdc, 0x3f, 0x80,
  4, 3, 14, 1, 253, // 005b bracketleft
  91, 5, 0x38, 0x2e, 0xb0, 0x4e, 0x0,
  4, 4, 11, 0, 0, // 005c backslash
  92, 4, 0xb9, 0xa5, 0xa5, 0xa5,
  4, 3, 14, 0, 253, // 005d bracketright
  93, 5, 0x38, 0x2, 0xb, 0x4, 0xe0,
  7, 5, 5, 1, 6, // 005e asciicircum
  94, 5, 0x8, 0x5, 0x4, 0x88, 0x40,
  8, 8, 1, 0, 253, // 005f underscore
  95, 1, 0xfc,
  5, 2, 2, 1, 9, // 0060 grave
  96, 2, 0xba, 0x80,
  8, 7, 8, 1, 0, // 0061 a
  97, 10, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76,
  7, 6, 11, 1, 0, // 0062 b
  98, 9, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x2e, 0x0,
  7, 6, 8, 1, 0, // 0063 c
  99, 8, 0x1e, 0xc, 0xcb, 0x94, 0x84, 0x33, 0x7, 0x80,
  8, 6, 11, 1, 0, // 0064 d
  100, 9, 0x1, 0x14, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd0,
  8, 6, 8, 1, 0, // 0065 e
  101, 9, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  4, 4, 11, 0, 0, // 0066 f
  102, 5, 0xc, 0x4, 0x6, 0xff, 0xa2,
  8, 6, 11, 1, 253, // 0067 g
  103, 11, 0x1d, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x74, 0x1, 0xc, 0xc1, 0xe0,
  8, 6, 11, 1, 0, // 0068 h
  104, 6, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x84,
  3, 1, 11, 1, 0, // 0069 i
  105, 3, 0xb9, 0xeb, 0xa3,
  3, 3, 14, 255, 253, // 006a j
  106, 6, 0x8, 0x1e, 0x8, 0x23, 0x53, 0x0,
  7, 6, 11, 1, 0, // 006b k
  107, 12, 0xb9, 0x48, 0x82, 0x40, 0xa0, 0x30, 0xa, 0x2, 0x40, 0x88, 0x21, 0x0,
  3, 1, 11, 1, 0, // 006c l
  108, 2, 0xba, 0xc0,
  11, 9, 8, 1, 0, // 006d m
  109, 6, 0x2c, 0xd3, 0x32, 0xef, 0x6c, 0x10,
  8, 6, 8, 1, 0, // 006e n
  110, 5, 0x2e, 0xc, 0xc2, 0x12, 0x10,
  8, 6, 8, 1, 0, // 006f o
  111, 7, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  8, 6, 11, 1, 253, // 0070 p
  112, 9, 0x2e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0xb8, 0xb9, 0x40,
  8, 6, 11, 1, 253, // 0071 q
  113, 9, 0x1d, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x74, 0x1, 0x14,
  5, 4, 8, 1, 0, // 0072 r
  114, 4, 0x2c, 0xc, 0xc, 0x84,
  7, 5, 8, 1, 0, // 0073 s
  115, 10, 0x1c, 0x8, 0x83, 0x0, 0x70, 0x6, 0x3c, 0x22, 0x7, 0x0,
  4, 4, 10, 0, 0, // 0074 t
  116, 5, 0x10, 0x1b, 0xfe, 0x84, 0x30,
  7, 6, 8, 1, 0, // 0075 u
  117, 5, 0x21, 0x21, 0x33, 0x7, 0x40,
  7, 7, 8, 0, 0, // 0076 v
  118, 6, 0x20, 0x91, 0x11, 0x42, 0x87, 0xe0,
  10, 9, 8, 0, 0, // 0077 w
  119, 9, 0x22, 0x2e, 0x80, 0x49, 0xe5, 0x15, 0x50, 0x89, 0x50,
  7, 7, 8, 0, 0, // 0078 x
  120, 9, 0x31, 0x84, 0x40, 0xa3, 0xe4, 0x28, 0x11, 0xc, 0x60,
  7, 7, 11, 0, 253, // 0079 y
  121, 10, 0x20, 0x8c, 0x21, 0x11, 0x9, 0x2, 0x80, 0x63, 0xd7, 0x70,
  7, 6, 8, 0, 0, // 007a z
  122, 7, 0x3f, 0x0, 0x4c, 0xcc, 0xcc, 0x3f, 0x0,
  5, 5, 14, 0, 253, // 007b braceleft
  123, 8, 0x6, 0x2, 0x5, 0x73, 0x2a, 0xa0, 0x6, 0x0,
  3, 1, 14, 1, 253, // 007c bar
  124, 2, 0xba, 0xc3,
  5, 5, 14, 0, 253, // 007d braceright
  125, 8, 0x30, 0x2, 0x5, 0x6a, 0xb3, 0x20, 0x30, 0x0,
  8, 6, 3, 1, 3, // 007e asciitilde
  126, 4, 0x19, 0xb, 0x42, 0x60,
  0xff]

/**
The characters from the Latin-1 Supplement Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Latin-1_Supplement_%28Unicode_block%29 )
This block has 96 assigned code points, and they are all
  present in this font.
  This block contains characters in the range 0x0080-0x00ff.
  The bitmaps for this block in this font take up about 1912 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
LATIN_1_SUPPLEMENT ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0x78, 0x7, 0x0, 0x0, // Length 1912.
  0xf0, 0x13, 0xda, 0xb1, 0x87, 0xc6, 0xc1, 0xdf, 0x72, 0x2c, 0xb3, 0x17, 0x54, 0xb3, 0x61, 0x71, 0x9c, 0xe6, 0xa3, 0xfa, 0x32, 0x9d, 0x52, 0xfb, 0x4a, 0x1d, 0x14, 0x63, 0x7a, 0x2, 0x2f, 0x7f, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x80, 0x0, 0x0, // Unicode range start 0x000080.
  116, 0xff, 0x0, 0x0, // Unicode range end 0x0000ff.
  0,
  4, 1, 0, 0, 0, // 00a0 space
  128, 160, 0,
  4, 1, 11, 1, 253, // 00a1 exclamdown
  128, 161, 3, 0xb9, 0xeb, 0xa3,
  8, 6, 10, 1, 255, // 00a2 cent
  128, 162, 11, 0x1, 0x7, 0x83, 0x30, 0x90, 0x4a, 0x2, 0x90, 0xcc, 0x1e, 0x2e,
  8, 7, 11, 0, 0, // 00a3 sterling
  128, 163, 10, 0xe, 0x4, 0x41, 0x1, 0x3e, 0x2, 0x5, 0xc1, 0x88, 0xdc,
  8, 6, 6, 1, 2, // 00a4 currency
  128, 164, 7, 0x21, 0x7, 0x81, 0x21, 0x1e, 0x8, 0x40,
  7, 7, 11, 0, 0, // 00a5 yen
  128, 165, 10, 0x20, 0x94, 0x44, 0x42, 0x83, 0xf8, 0x10, 0x3f, 0x81, 0x4,
  3, 1, 14, 1, 253, // 00a6 brokenbar
  128, 166, 4, 0xba, 0x1e, 0x6e, 0x84,
  8, 5, 14, 2, 253, // 00a7 section
  128, 167, 17, 0x1c, 0xd, 0x82, 0x20, 0xc0, 0x1c, 0x9, 0x82, 0x21, 0x32, 0x7, 0x0, 0x60, 0x88, 0x36, 0x7, 0x0,
  5, 5, 1, 0, 9, // 00a8 dieresis
  128, 168, 2, 0x36, 0x0,
  12, 10, 11, 1, 0, // 00a9 copyright
  128, 169, 18, 0x7, 0x91, 0x86, 0xe1, 0x71, 0x28, 0xa5, 0xf0, 0xa0, 0x4a, 0x24, 0x9c, 0x44, 0xc, 0x18, 0x50, 0x7b, 0x80,
  6, 4, 7, 1, 4, // 00aa ordfeminine
  128, 170, 8, 0x38, 0x1, 0x1, 0xc0, 0x90, 0x34, 0x38, 0xf0,
  8, 6, 5, 1, 2, // 00ab guillemotleft
  128, 171, 4, 0x9, 0x33, 0x2a, 0x80,
  9, 7, 4, 1, 2, // 00ac logicalnot
  128, 172, 3, 0x3f, 0x80, 0x25,
  4, 3, 1, 0, 4, // 00ad hyphen
  128, 173, 2, 0x38, 0x0,
  12, 10, 11, 1, 0, // 00ae registered
  128, 174, 16, 0x7, 0x91, 0x86, 0xe1, 0x71, 0x24, 0xa9, 0x49, 0xc4, 0x92, 0x54, 0x40, 0xc1, 0x85, 0x7, 0xb8,
  4, 4, 1, 0, 9, // 00af macron
  128, 175, 2, 0x3c, 0x0,
  6, 4, 4, 1, 7, // 00b0 degree
  128, 176, 4, 0x18, 0x9, 0x4, 0x60,
  9, 7, 9, 1, 0, // 00b1 plusminus
  128, 177, 7, 0x4, 0x14, 0xfe, 0x4, 0x17, 0x8f, 0xe0,
  5, 4, 6, 0, 5, // 00b2 twosuperior
  128, 178, 6, 0x18, 0x9, 0x0, 0x43, 0x30, 0xf0,
  5, 4, 6, 0, 5, // 00b3 threesuperior
  128, 179, 6, 0x18, 0x9, 0xc, 0xa2, 0x40, 0x60,
  5, 2, 2, 2, 9, // 00b4 acute
  128, 180, 2, 0x10, 0x30,
  8, 6, 11, 1, 253, // 00b5 mu
  128, 181, 6, 0x21, 0x21, 0x33, 0xb, 0x4b, 0x94,
  8, 7, 14, 0, 253, // 00b6 paragraph
  128, 182, 9, 0xf, 0x87, 0x43, 0xd1, 0x47, 0x40, 0xd0, 0x14, 0x88,
  4, 2, 1, 1, 4, // 00b7 periodcentered
  128, 183, 2, 0x30, 0x0,
  5, 4, 3, 0, 253, // 00b8 cedilla
  128, 184, 4, 0x8, 0x9, 0x1, 0x80,
  5, 2, 6, 1, 5, // 00b9 onesuperior
  128, 185, 4, 0x10, 0x37, 0xc5, 0x40,
  6, 4, 7, 1, 4, // 00ba ordmasculine
  128, 186, 6, 0x18, 0x9, 0x5, 0x18, 0x38, 0xf0,
  8, 6, 5, 1, 2, // 00bb guillemotright
  128, 187, 4, 0x24, 0x2a, 0xb3, 0x0,
  12, 10, 11, 1, 0, // 00bc onequarter
  128, 188, 15, 0x10, 0x93, 0x9, 0x11, 0x15, 0x12, 0x16, 0xe0, 0x25, 0xc4, 0x14, 0x42, 0x79, 0x8, 0x30,
  12, 9, 11, 1, 0, // 00bd onehalf
  128, 189, 16, 0x10, 0x93, 0x9, 0x11, 0x15, 0x12, 0x11, 0x2d, 0x5, 0x2e, 0x4, 0x10, 0x47, 0xb1, 0x9, 0xee,
  12, 11, 11, 0, 0, // 00be threequarters
  128, 190, 19, 0x18, 0x52, 0x45, 0xc4, 0x12, 0x49, 0x44, 0x64, 0x10, 0x0, 0x4d, 0x2, 0x7c, 0x2, 0x90, 0x4e, 0xf0, 0x43, 0xe0,
  8, 6, 11, 1, 253, // 00bf questiondown
  128, 191, 9, 0x4, 0x1e, 0x4, 0x33, 0x30, 0x84, 0x4c, 0xc0, 0xc0,
  9, 9, 14, 0, 0, // 00c0 Agrave
  128, 192, 16, 0x4, 0x1a, 0x79, 0x2, 0x1b, 0xd0, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5,
  9, 9, 14, 0, 0, // 00c1 Aacute
  128, 193, 16, 0x1, 0x1c, 0x79, 0x2, 0x1b, 0xd0, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5,
  9, 9, 14, 0, 0, // 00c2 Acircumflex
  128, 194, 17, 0x3, 0x10, 0x49, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  9, 9, 14, 0, 0, // 00c3 Atilde
  128, 195, 17, 0x6, 0x90, 0xb1, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  9, 9, 13, 0, 0, // 00c4 Adieresis
  128, 196, 16, 0xd, 0x9e, 0x40, 0x86, 0xf4, 0x14, 0x54, 0x22, 0x54, 0x41, 0x47, 0xf4, 0x41, 0x6e, 0xb9, 0x40,
  9, 9, 14, 0, 0, // 00c5 Aring
  128, 197, 16, 0x3, 0x10, 0x49, 0x50, 0x31, 0x50, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5,
  14, 12, 11, 1, 0, // 00c6 AE
  128, 198, 17, 0x7, 0xcf, 0x0, 0x4b, 0x94, 0x22, 0x54, 0x23, 0x3c, 0x7, 0xee, 0x10, 0x95, 0x20, 0x92, 0xc, 0xf0,
  10, 8, 14, 1, 253, // 00c7 Ccedilla
  128, 199, 13, 0x7, 0x6, 0x31, 0x6, 0xe8, 0x4, 0x11, 0x8c, 0x1c, 0xf8, 0x24, 0x6, 0x0,
  9, 7, 14, 1, 0, // 00c8 Egrave
  128, 200, 9, 0x8, 0x2b, 0x8f, 0xeb, 0x95, 0x3f, 0x2e, 0x54, 0xfe,
  9, 7, 14, 1, 0, // 00c9 Eacute
  128, 201, 9, 0x2, 0x33, 0x8f, 0xeb, 0x95, 0x3f, 0x2e, 0x54, 0xfe,
  9, 7, 14, 1, 0, // 00ca Ecircumflex
  128, 202, 10, 0x6, 0x2, 0x4e, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8,
  9, 7, 13, 1, 0, // 00cb Edieresis
  128, 203, 9, 0x1b, 0x38, 0xfe, 0xb9, 0x53, 0xf2, 0xe5, 0x4f, 0xe0,
  4, 2, 14, 1, 0, // 00cc Igrave
  128, 204, 5, 0xba, 0xb8, 0x40, 0xb0, 0x0,
  4, 2, 14, 2, 0, // 00cd Iacute
  128, 205, 5, 0x10, 0x33, 0xae, 0xb0, 0x0,
  4, 4, 14, 1, 0, // 00ce Icircumflex
  128, 206, 6, 0x18, 0x9, 0xe, 0x10, 0x2c, 0x0,
  4, 5, 13, 0, 0, // 00cf Idieresis
  128, 207, 5, 0x36, 0x38, 0x20, 0xb0, 0x0,
  10, 9, 11, 0, 0, // 00d0 Eth
  128, 208, 16, 0x1f, 0x11, 0xd, 0x10, 0x51, 0x2, 0xe5, 0x3c, 0x11, 0x1, 0x51, 0x7, 0x84, 0x34, 0x7c, 0x40,
  10, 8, 14, 1, 0, // 00d1 Ntilde
  128, 209, 12, 0x6, 0x82, 0xce, 0x30, 0x4a, 0x14, 0x91, 0x48, 0x94, 0x85, 0x48, 0x34,
  11, 9, 14, 1, 0, // 00d2 Ograve
  128, 210, 15, 0x4, 0x1a, 0x79, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x8d, 0x10, 0x78, 0x63, 0x41, 0xc4,
  11, 9, 14, 1, 0, // 00d3 Oacute
  128, 211, 15, 0x1, 0x1c, 0x79, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x8d, 0x10, 0x78, 0x63, 0x41, 0xc4,
  11, 9, 14, 1, 0, // 00d4 Ocircumflex
  128, 212, 16, 0x3, 0x10, 0x49, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  11, 9, 14, 1, 0, // 00d5 Otilde
  128, 213, 16, 0x6, 0x90, 0xb1, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  11, 9, 13, 1, 0, // 00d6 Odieresis
  128, 214, 14, 0xc, 0xde, 0x41, 0xc4, 0x63, 0x44, 0x16, 0xeb, 0xa3, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  9, 7, 7, 1, 1, // 00d7 multiply
  128, 215, 9, 0x20, 0x84, 0x40, 0xa3, 0xe0, 0xa0, 0x44, 0x20, 0x80,
  11, 11, 11, 0, 0, // 00d8 Oslash
  128, 216, 19, 0x3, 0x82, 0x0, 0xc4, 0xc0, 0xf7, 0x4, 0x1a, 0x10, 0x91, 0x11, 0x12, 0x11, 0x41, 0xfb, 0x7, 0x14, 0x8e, 0xe0,
  10, 8, 14, 1, 0, // 00d9 Ugrave
  128, 217, 7, 0x4, 0x2b, 0x88, 0x18, 0xd1, 0x8, 0x3c,
  10, 8, 14, 1, 0, // 00da Uacute
  128, 218, 7, 0x1, 0x33, 0x88, 0x18, 0xd1, 0x8, 0x3c,
  10, 8, 14, 1, 0, // 00db Ucircumflex
  128, 219, 8, 0x6, 0x2, 0x4e, 0x20, 0x63, 0x44, 0x20, 0xf0,
  10, 8, 13, 1, 0, // 00dc Udieresis
  128, 220, 7, 0x19, 0xb8, 0x81, 0x8d, 0x10, 0x83, 0xc0,
  9, 9, 14, 0, 0, // 00dd Yacute
  128, 221, 15, 0x1, 0x1c, 0x79, 0xba, 0xe3, 0x5, 0x10, 0x78, 0x22, 0x54, 0x14, 0x41, 0xc7, 0xe8, 0xc0,
  9, 7, 11, 1, 0, // 00de Thorn
  128, 222, 8, 0xb9, 0x3f, 0x8, 0x62, 0x9, 0xd3, 0xf2, 0xe5,
  7, 5, 11, 1, 0, // 00df germandbls
  128, 223, 9, 0x1c, 0x8, 0x85, 0x2c, 0x9, 0x2, 0x21, 0x52, 0xc0,
  8, 7, 11, 1, 0, // 00e0 agrave
  128, 224, 13, 0x8, 0x2b, 0x87, 0x83, 0x30, 0x4, 0x1f, 0xc, 0x42, 0x10, 0xcc, 0x1d, 0x80,
  8, 7, 11, 1, 0, // 00e1 aacute
  128, 225, 13, 0x4, 0x33, 0x87, 0x83, 0x30, 0x4, 0x1f, 0xc, 0x42, 0x10, 0xcc, 0x1d, 0x80,
  8, 7, 11, 1, 0, // 00e2 acircumflex
  128, 226, 13, 0xc, 0x4, 0x8e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76,
  8, 7, 11, 1, 0, // 00e3 atilde
  128, 227, 13, 0xd, 0x5, 0x8e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76,
  8, 7, 11, 1, 0, // 00e4 adieresis
  128, 228, 12, 0x12, 0x1e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76,
  8, 7, 12, 1, 0, // 00e5 aring
  128, 229, 15, 0xc, 0x4, 0x80, 0xc3, 0x87, 0x83, 0x30, 0x4, 0x1f, 0xc, 0x42, 0x10, 0xcc, 0x1d, 0x80,
  13, 11, 8, 1, 0, // 00e6 ae
  128, 230, 16, 0x1e, 0xcc, 0x3, 0x1a, 0x80, 0x4f, 0x7, 0xf3, 0x80, 0xc4, 0xe2, 0x11, 0xbc, 0x60, 0x1e, 0xf0,
  8, 6, 11, 1, 253, // 00e7 ccedilla
  128, 231, 12, 0x1e, 0xc, 0xcb, 0x94, 0x84, 0x33, 0x7, 0x80, 0x40, 0x48, 0xc, 0x0,
  8, 6, 11, 1, 0, // 00e8 egrave
  128, 232, 11, 0x8, 0x2b, 0x87, 0x83, 0x30, 0x84, 0x3f, 0x2e, 0x4c, 0xc1, 0xe0,
  8, 6, 11, 1, 0, // 00e9 eacute
  128, 233, 11, 0x4, 0x33, 0x87, 0x83, 0x30, 0x84, 0x3f, 0x2e, 0x4c, 0xc1, 0xe0,
  8, 6, 11, 1, 0, // 00ea ecircumflex
  128, 234, 12, 0xc, 0x4, 0x8e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  8, 6, 11, 1, 0, // 00eb edieresis
  128, 235, 11, 0x12, 0x1e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  3, 2, 11, 1, 0, // 00ec igrave
  128, 236, 4, 0xba, 0xba, 0xe8, 0xc0,
  3, 2, 11, 1, 0, // 00ed iacute
  128, 237, 4, 0x10, 0x33, 0xae, 0x8c,
  3, 4, 11, 0, 0, // 00ee icircumflex
  128, 238, 5, 0x18, 0x9, 0xe, 0x10, 0x23,
  3, 3, 11, 0, 0, // 00ef idieresis
  128, 239, 4, 0x28, 0x1e, 0x10, 0x23,
  8, 6, 11, 1, 0, // 00f0 eth
  128, 240, 11, 0x36, 0x7, 0x2, 0x40, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0,
  8, 6, 11, 1, 0, // 00f1 ntilde
  128, 241, 8, 0x1a, 0xb, 0xe, 0x2e, 0xc, 0xc2, 0x12, 0x10,
  8, 6, 11, 1, 0, // 00f2 ograve
  128, 242, 10, 0x8, 0x2b, 0x87, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x1e, 0x0,
  8, 6, 11, 1, 0, // 00f3 oacute
  128, 243, 10, 0x4, 0x33, 0x87, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x1e, 0x0,
  8, 6, 11, 1, 0, // 00f4 ocircumflex
  128, 244, 10, 0xc, 0x4, 0x8e, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  8, 6, 11, 1, 0, // 00f5 otilde
  128, 245, 10, 0x1a, 0xb, 0xe, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  8, 6, 11, 1, 0, // 00f6 odieresis
  128, 246, 9, 0x12, 0x1e, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  9, 7, 7, 1, 1, // 00f7 divide
  128, 247, 6, 0x4, 0x1e, 0x3f, 0xb8, 0x10, 0x40,
  8, 8, 8, 0, 0, // 00f8 oslash
  128, 248, 10, 0xf, 0x46, 0x21, 0x18, 0x4a, 0x14, 0x86, 0x21, 0x18, 0xbc,
  8, 6, 11, 1, 0, // 00f9 ugrave
  128, 249, 7, 0x8, 0x2b, 0x88, 0x48, 0x4c, 0xc1, 0xd0,
  8, 6, 11, 1, 0, // 00fa uacute
  128, 250, 7, 0x4, 0x33, 0x88, 0x48, 0x4c, 0xc1, 0xd0,
  8, 6, 11, 1, 0, // 00fb ucircumflex
  128, 251, 8, 0xc, 0x4, 0x8e, 0x21, 0x21, 0x33, 0x7, 0x40,
  8, 6, 11, 1, 0, // 00fc udieresis
  128, 252, 7, 0x12, 0x1e, 0x21, 0x21, 0x33, 0x7, 0x40,
  7, 7, 14, 0, 253, // 00fd yacute
  128, 253, 12, 0x2, 0x33, 0x88, 0x23, 0x8, 0x44, 0x42, 0x40, 0xa0, 0x18, 0xf5, 0xdc,
  8, 6, 14, 1, 253, // 00fe thorn
  128, 254, 10, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x2e, 0x2e, 0x50,
  7, 7, 14, 0, 253, // 00ff ydieresis
  128, 255, 12, 0x9, 0x1e, 0x20, 0x8c, 0x21, 0x11, 0x9, 0x2, 0x80, 0x63, 0xd7, 0x70,
  0xff]

/**
The characters from the Latin Extended-A Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Latin_Extended-A )
This block has 128 assigned code points, and 127 of
  them are present in this font.
  This block contains characters in the range 0x0100-0x017f.
  The bitmaps for this block in this font take up about 2518 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
LATIN_EXTENDED_A ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0xd6, 0x9, 0x0, 0x0, // Length 2518.
  0xfc, 0xaf, 0x40, 0x69, 0x7b, 0x5c, 0x4c, 0x17, 0x17, 0x98, 0xd0, 0x54, 0xcf, 0x46, 0x32, 0x39, 0x17, 0x87, 0x1f, 0x22, 0xe4, 0x5e, 0xfe, 0x52, 0x12, 0x15, 0x8, 0xa3, 0x1a, 0xca, 0xea, 0xb7, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x0, 0x1, 0x0, // Unicode range start 0x000100.
  116, 0x7f, 0x1, 0x0, // Unicode range end 0x00017f.
  0,
  9, 9, 13, 0, 0, // 0100 Amacron
  129, 0, 16, 0x7, 0x9e, 0x40, 0x86, 0xf4, 0x14, 0x54, 0x22, 0x54, 0x41, 0x47, 0xf4, 0x41, 0x6e, 0xb9, 0x40,
  8, 7, 10, 1, 0, // 0101 amacron
  129, 1, 12, 0x1e, 0x38, 0x78, 0x33, 0x0, 0x41, 0xf0, 0xc4, 0x21, 0xc, 0xc1, 0xd8,
  9, 9, 14, 0, 0, // 0102 Abreve
  129, 2, 17, 0x8, 0x90, 0x71, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  8, 7, 11, 1, 0, // 0103 abreve
  129, 3, 13, 0x11, 0x3, 0x8e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76,
  9, 9, 14, 0, 253, // 0104 Aogonek
  129, 4, 17, 0x2, 0x1b, 0xd0, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5, 0x2, 0x3b, 0x10, 0x71,
  8, 7, 11, 1, 253, // 0105 aogonek
  129, 5, 13, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76, 0x4, 0x30, 0x38,
  10, 8, 14, 1, 0, // 0106 Cacute
  129, 6, 12, 0x1, 0x33, 0x81, 0xc1, 0x8c, 0x41, 0xba, 0x1, 0x4, 0x63, 0x7, 0x0,
  7, 6, 11, 1, 0, // 0107 cacute
  129, 7, 10, 0x4, 0x33, 0x87, 0x83, 0x32, 0xe5, 0x21, 0xc, 0xc1, 0xe0,
  10, 8, 14, 1, 0, // 0108 Ccircumflex
  129, 8, 12, 0x2, 0x1, 0x4e, 0x7, 0x6, 0x31, 0x6, 0xe8, 0x4, 0x11, 0x8c, 0x1c,
  7, 6, 11, 1, 0, // 0109 ccircumflex
  129, 9, 11, 0x8, 0x5, 0xe, 0x1e, 0xc, 0xcb, 0x94, 0x84, 0x33, 0x7, 0x80,
  10, 8, 13, 1, 0, // 010a Cdotaccent
  129, 10, 11, 0x6, 0x38, 0x1c, 0x18, 0xc4, 0x1b, 0xa0, 0x10, 0x46, 0x30, 0x70,
  7, 6, 10, 1, 0, // 010b cdotaccent
  129, 11, 10, 0xc, 0x38, 0x78, 0x33, 0x2e, 0x52, 0x10, 0xcc, 0x1e, 0x0,
  10, 8, 14, 1, 0, // 010c Ccaron
  129, 12, 12, 0x5, 0x3e, 0xe0, 0x70, 0x63, 0x10, 0x6e, 0x80, 0x41, 0x18, 0xc1, 0xc0,
  7, 6, 11, 1, 0, // 010d ccaron
  129, 13, 10, 0x14, 0x3e, 0xe1, 0xe0, 0xcc, 0xb9, 0x48, 0x43, 0x30, 0x78,
  10, 8, 14, 1, 0, // 010e Dcaron
  129, 14, 12, 0xa, 0x3e, 0xe3, 0xe0, 0x86, 0x20, 0x88, 0x18, 0x8, 0x2d, 0x3e, 0x0,
  11, 10, 11, 1, 0, // 010f dcaron
  129, 15, 13, 0x1, 0xc, 0x7, 0xc7, 0x7, 0x4e, 0x33, 0x12, 0x12, 0x33, 0x31, 0x1d, 0x10,
  10, 9, 11, 0, 0, // 0110 Dcroat
  129, 16, 16, 0x1f, 0x11, 0xd, 0x10, 0x51, 0x2, 0xe5, 0x3c, 0x11, 0x1, 0x51, 0x7, 0x84, 0x34, 0x7c, 0x40,
  8, 6, 11, 1, 0, // 0111 dcroat
  129, 17, 11, 0x1, 0x3, 0xc0, 0x10, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd0,
  9, 7, 13, 1, 0, // 0112 Emacron
  129, 18, 9, 0x1e, 0x38, 0xfe, 0xb9, 0x53, 0xf2, 0xe5, 0x4f, 0xe0,
  8, 6, 10, 1, 0, // 0113 emacron
  129, 19, 11, 0x1e, 0x38, 0x78, 0x33, 0x8, 0x43, 0xf2, 0xe4, 0xcc, 0x1e, 0x0,
  9, 7, 14, 1, 0, // 0114 Ebreve
  129, 20, 10, 0x11, 0x3, 0x8e, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8,
  8, 6, 11, 1, 0, // 0115 ebreve
  129, 21, 12, 0x11, 0x3, 0x8e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  9, 7, 13, 1, 0, // 0116 Edotaccent
  129, 22, 9, 0xc, 0x38, 0xfe, 0xb9, 0x53, 0xf2, 0xe5, 0x4f, 0xe0,
  8, 6, 10, 1, 0, // 0117 edotaccent
  129, 23, 11, 0xc, 0x38, 0x78, 0x33, 0x8, 0x43, 0xf2, 0xe4, 0xcc, 0x1e, 0x0,
  9, 7, 14, 1, 253, // 0118 Eogonek
  129, 24, 10, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8, 0x10, 0xc0, 0xe0,
  8, 6, 11, 1, 253, // 0119 eogonek
  129, 25, 12, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80, 0x83, 0x7, 0x0,
  9, 7, 14, 1, 0, // 011a Ecaron
  129, 26, 10, 0xa, 0x3e, 0xe3, 0xfa, 0xe5, 0x4f, 0xcb, 0x95, 0x3f, 0x80,
  8, 6, 11, 1, 0, // 011b ecaron
  129, 27, 11, 0xa, 0x3e, 0xe1, 0xe0, 0xcc, 0x21, 0xf, 0xcb, 0x93, 0x30, 0x78,
  11, 9, 14, 1, 0, // 011c Gcircumflex
  129, 28, 17, 0x2, 0x10, 0x51, 0xe4, 0x1e, 0x46, 0x1b, 0xbd, 0x73, 0x94, 0x87, 0xba, 0xe5, 0x69, 0x18, 0xd0, 0x71,
  8, 6, 14, 1, 253, // 011d gcircumflex
  129, 29, 14, 0x4, 0x2, 0x8e, 0x1d, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x74, 0x1, 0xc, 0xc1, 0xe0,
  11, 9, 14, 1, 0, // 011e Gbreve
  129, 30, 17, 0x8, 0x90, 0x71, 0xe4, 0x1e, 0x46, 0x1b, 0xbd, 0x73, 0x94, 0x87, 0xba, 0xe5, 0x69, 0x18, 0xd0, 0x71,
  8, 6, 14, 1, 253, // 011f gbreve
  129, 31, 14, 0x11, 0x3, 0x8e, 0x1d, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x74, 0x1, 0xc, 0xc1, 0xe0,
  11, 9, 13, 1, 0, // 0120 Gdotaccent
  129, 32, 16, 0x3, 0x1e, 0x41, 0xe4, 0x61, 0xbb, 0xd7, 0x39, 0x48, 0x7b, 0xae, 0x56, 0x91, 0x8d, 0x7, 0x10,
  8, 6, 13, 1, 253, // 0121 gdotaccent
  129, 33, 13, 0xc, 0x38, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd0, 0x4, 0x33, 0x7, 0x80,
  11, 9, 16, 1, 251, // 0122 Gcommaaccent
  129, 34, 17, 0x7, 0x91, 0x86, 0xef, 0x5c, 0xe5, 0x21, 0xee, 0xb9, 0x5a, 0x46, 0x34, 0x1c, 0x7b, 0x80, 0x48, 0x71,
  8, 6, 15, 1, 253, // 0123 gcommaaccent
  129, 35, 14, 0x4, 0x32, 0x78, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd0, 0x4, 0x33, 0x7, 0x80,
  10, 8, 14, 1, 0, // 0124 Hcircumflex
  129, 36, 8, 0x2, 0x1, 0x4e, 0x20, 0x60, 0xfc, 0x81, 0x80,
  8, 6, 14, 1, 0, // 0125 hcircumflex
  129, 37, 9, 0x10, 0xa, 0xe, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x84,
  10, 8, 11, 1, 0, // 0126 Hbar
  129, 38, 7, 0x20, 0x5f, 0xc8, 0x17, 0xf2, 0x6, 0x0,
  8, 6, 11, 1, 0, // 0127 hbar
  129, 39, 8, 0xb8, 0xf0, 0xb8, 0xb8, 0x33, 0x8, 0x48, 0x40,
  4, 5, 14, 0, 0, // 0128 Itilde
  129, 40, 6, 0x1a, 0xb, 0xe, 0x8, 0x2c, 0x0,
  3, 5, 11, 255, 0, // 0129 itilde
  129, 41, 5, 0x1a, 0xb, 0xe, 0x8, 0x23,
  4, 4, 13, 1, 0, // 012a Imacron
  129, 42, 5, 0x3c, 0x38, 0x40, 0xb0, 0x0,
  3, 4, 10, 0, 0, // 012b imacron
  129, 43, 4, 0x3c, 0x38, 0x40, 0x8c,
  4, 5, 14, 0, 0, // 012c Ibreve
  129, 44, 6, 0x22, 0x7, 0xe, 0x8, 0x2c, 0x0,
  3, 5, 11, 255, 0, // 012d ibreve
  129, 45, 5, 0x22, 0x7, 0xe, 0x8, 0x23,
  4, 3, 14, 1, 253, // 012e Iogonek
  129, 46, 5, 0x10, 0x2c, 0x1c, 0x38, 0x0,
  3, 3, 14, 0, 253, // 012f iogonek
  129, 47, 6, 0x10, 0x1e, 0x10, 0x23, 0x70, 0xe0,
  4, 2, 13, 2, 0, // 0130 Idotaccent
  129, 48, 4, 0x30, 0x3a, 0xeb, 0x0,
  3, 1, 8, 1, 0, // 0131 dotlessi
  129, 49, 2, 0xba, 0x30,
  11, 8, 11, 2, 0, // 0132 IJ
  129, 50, 5, 0x20, 0x63, 0x28, 0x52, 0x78,
  6, 4, 14, 1, 253, // 0133 ij
  129, 51, 7, 0x24, 0x1e, 0x24, 0x23, 0x4, 0x11, 0x80,
  7, 6, 14, 0, 0, // 0134 Jcircumflex
  129, 52, 8, 0x2, 0x1, 0x4e, 0x1, 0x23, 0x21, 0x11, 0xe0,
  3, 4, 14, 255, 253, // 0135 jcircumflex
  129, 53, 7, 0x8, 0x5, 0xe, 0x8, 0x23, 0x53, 0x0,
  9, 8, 16, 1, 251, // 0136 Kcommaaccent
  129, 54, 16, 0x20, 0x88, 0x42, 0x20, 0x90, 0x28, 0x34, 0x90, 0x22, 0x8, 0x42, 0x8, 0x81, 0xe0, 0x41, 0x70,
  7, 6, 16, 1, 251, // 0137 kcommaaccent
  129, 55, 14, 0xb9, 0x48, 0x82, 0x40, 0xa0, 0x30, 0xa, 0x2, 0x40, 0x88, 0x21, 0x38, 0x20, 0x5c,
  7, 6, 8, 1, 0, // 0138 kgreenlandic
  129, 56, 10, 0x22, 0x9, 0x2, 0x80, 0xc0, 0x28, 0x9, 0x2, 0x20, 0x84,
  8, 6, 14, 2, 0, // 0139 Lacute
  129, 57, 6, 0x8, 0x33, 0xae, 0x8d, 0x4f, 0xc0,
  3, 2, 14, 1, 0, // 013a lacute
  129, 58, 5, 0x10, 0x33, 0xae, 0xb0, 0x0,
  8, 6, 16, 2, 251, // 013b Lcommaaccent
  129, 59, 6, 0xba, 0x35, 0x3f, 0x38, 0x20, 0x5c,
  3, 2, 16, 0, 251, // 013c lcommaaccent
  129, 60, 6, 0x10, 0x2c, 0xe, 0x10, 0x17, 0x0,
  11, 9, 11, 2, 0, // 013d Lcaron
  129, 61, 9, 0x20, 0x6e, 0xb9, 0x20, 0x7a, 0xeb, 0xc, 0xfc, 0x40,
  6, 5, 11, 1, 0, // 013e lcaron
  129, 62, 6, 0x26, 0x8, 0x82, 0x42, 0xe8, 0xc0,
  12, 9, 11, 2, 0, // 013f Ldot
  129, 63, 8, 0xba, 0xc1, 0x20, 0x6e, 0xbb, 0xa0, 0x3f, 0x10,
  7, 5, 11, 1, 0, // 0140 ldot
  129, 64, 5, 0xba, 0x12, 0x62, 0xe5, 0x40,
  8, 8, 11, 255, 0, // 0141 Lslash
  129, 65, 9, 0x8, 0x14, 0x28, 0xc, 0x30, 0xa0, 0x8, 0x14, 0x3f,
  3, 3, 11, 0, 0, // 0142 lslash
  129, 66, 5, 0x10, 0x15, 0x9c, 0xf2, 0x0,
  10, 8, 14, 1, 0, // 0143 Nacute
  129, 67, 11, 0x2, 0x33, 0x8c, 0x12, 0x85, 0x24, 0x52, 0x25, 0x21, 0x52, 0xd,
  8, 6, 11, 1, 0, // 0144 nacute
  129, 68, 7, 0x4, 0x33, 0x8b, 0x83, 0x30, 0x84, 0x84,
  10, 8, 16, 1, 251, // 0145 Ncommaaccent
  129, 69, 12, 0x30, 0x4a, 0x14, 0x91, 0x48, 0x94, 0x85, 0x48, 0x37, 0x80, 0x85, 0xc0,
  8, 6, 13, 1, 251, // 0146 ncommaaccent
  129, 70, 8, 0x2e, 0xc, 0xc2, 0x12, 0x1e, 0x4, 0x17, 0x0,
  10, 8, 14, 1, 0, // 0147 Ncaron
  129, 71, 12, 0xa, 0x3e, 0xe3, 0x4, 0xa1, 0x49, 0x14, 0x89, 0x48, 0x54, 0x83, 0x40,
  8, 6, 11, 1, 0, // 0148 ncaron
  129, 72, 7, 0x14, 0x3e, 0xe2, 0xe0, 0xcc, 0x21, 0x21,
  11, 9, 11, 1, 0, // 0149 napostrophe
  129, 73, 9, 0x30, 0x1f, 0x1c, 0x41, 0x74, 0x19, 0xbb, 0xdb, 0x4,
  10, 8, 14, 1, 253, // 014a Eng
  129, 74, 11, 0x30, 0x4a, 0x14, 0x91, 0x48, 0x94, 0x85, 0x48, 0x37, 0xc4, 0x6,
  8, 6, 11, 1, 253, // 014b eng
  129, 75, 8, 0x2e, 0xc, 0xc2, 0x12, 0x10, 0x11, 0x6, 0x0,
  11, 9, 13, 1, 0, // 014c Omacron
  129, 76, 14, 0x7, 0x9e, 0x41, 0xc4, 0x63, 0x44, 0x16, 0xeb, 0xa3, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  8, 6, 10, 1, 0, // 014d omacron
  129, 77, 9, 0x1e, 0x38, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0,
  11, 9, 14, 1, 0, // 014e Obreve
  129, 78, 16, 0x8, 0x90, 0x71, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  8, 6, 11, 1, 0, // 014f obreve
  129, 79, 10, 0x11, 0x3, 0x8e, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  11, 9, 15, 1, 0, // 0150 Ohungarumlaut
  129, 80, 16, 0x1, 0x5c, 0x71, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  8, 6, 12, 1, 0, // 0151 ohungarumlaut
  129, 81, 10, 0x5, 0x33, 0x38, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0,
  15, 13, 11, 1, 0, // 0152 OE
  129, 82, 16, 0x7, 0xcf, 0x81, 0x8f, 0x84, 0x14, 0x81, 0x80, 0xf8, 0x79, 0x44, 0x14, 0x63, 0x41, 0xf3, 0xe0,
  13, 11, 8, 1, 0, // 0153 oe
  129, 83, 15, 0x1e, 0xcc, 0x3, 0x3a, 0x88, 0x4f, 0x8, 0x73, 0x80, 0x84, 0xe5, 0xbc, 0x60, 0x1e, 0xf0,
  10, 8, 14, 1, 0, // 0154 Racute
  129, 84, 12, 0x2, 0x33, 0x8f, 0xe2, 0xc, 0x81, 0x48, 0x23, 0xf0, 0x82, 0x20, 0x55,
  5, 4, 11, 1, 0, // 0155 racute
  129, 85, 6, 0x8, 0x33, 0x8b, 0x3, 0x3, 0x21,
  10, 8, 16, 1, 251, // 0156 Rcommaaccent
  129, 86, 13, 0x3f, 0x88, 0x32, 0x5, 0x20, 0x8f, 0xc2, 0x8, 0x81, 0x57, 0x80, 0x85, 0xc0,
  5, 4, 13, 1, 251, // 0157 rcommaaccent
  129, 87, 7, 0x2c, 0xc, 0xc, 0x87, 0x84, 0x5, 0xc0,
  10, 8, 14, 1, 0, // 0158 Rcaron
  129, 88, 13, 0xa, 0x3e, 0xe3, 0xf8, 0x83, 0x20, 0x52, 0x8, 0xfc, 0x20, 0x88, 0x15, 0x40,
  5, 4, 11, 1, 0, // 0159 rcaron
  129, 89, 6, 0x28, 0x33, 0x8b, 0x3, 0x3, 0x21,
  9, 7, 14, 1, 0, // 015a Sacute
  129, 90, 15, 0x2, 0x33, 0x83, 0x83, 0x18, 0x82, 0xb8, 0x60, 0x6, 0x0, 0x6f, 0x8, 0x23, 0x18, 0x38,
  7, 5, 11, 1, 0, // 015b sacute
  129, 91, 12, 0x4, 0x33, 0x87, 0x2, 0x20, 0xc0, 0x1c, 0x1, 0x8f, 0x8, 0x81, 0xc0,
  9, 7, 14, 1, 0, // 015c Scircumflex
  129, 92, 16, 0x4, 0x2, 0x8e, 0xe, 0xc, 0x62, 0xa, 0xe1, 0x80, 0x18, 0x1, 0xbc, 0x20, 0x8c, 0x60, 0xe0,
  7, 5, 11, 1, 0, // 015d scircumflex
  129, 93, 13, 0x8, 0x5, 0xe, 0x1c, 0x8, 0x83, 0x0, 0x70, 0x6, 0x3c, 0x22, 0x7, 0x0,
  9, 7, 14, 1, 253, // 015e Scedilla
  129, 94, 16, 0xe, 0xc, 0x62, 0xa, 0xe1, 0x80, 0x18, 0x1, 0xbc, 0x20, 0x8c, 0x60, 0xe3, 0xe1, 0x20, 0x30,
  7, 5, 11, 1, 253, // 015f scedilla
  129, 95, 13, 0x1c, 0x8, 0x83, 0x0, 0x70, 0x6, 0x3c, 0x22, 0x7, 0xf, 0x89, 0x1, 0x80,
  9, 7, 11, 1, 0, // 0160 Scaron
  129, 96, 11, 0xa, 0x3e, 0xe1, 0xf0, 0x82, 0xb8, 0x7c, 0x0, 0x92, 0x8, 0x7c,
  8, 6, 11, 1, 0, // 0161 scaron
  129, 97, 12, 0x14, 0x3e, 0xe1, 0xe0, 0x84, 0xb8, 0x78, 0x3, 0x3c, 0x21, 0x7, 0x80,
  9, 9, 14, 0, 253, // 0162 Tcommaaccent
  129, 98, 8, 0xfe, 0xe0, 0x23, 0xac, 0xa0, 0x91, 0x6, 0x10,
  4, 4, 13, 0, 253, // 0163 tcommaaccent
  129, 99, 9, 0x10, 0x1b, 0xfe, 0x84, 0x30, 0xf4, 0x90, 0x18, 0x0,
  9, 9, 14, 0, 0, // 0164 Tcaron
  129, 100, 8, 0x5, 0x1f, 0x9e, 0x7f, 0xb8, 0x8, 0xeb, 0x20,
  7, 7, 11, 0, 0, // 0165 tcaron
  129, 101, 8, 0x1, 0x84, 0x21, 0x10, 0xe0, 0xfa, 0x10, 0xc0,
  9, 9, 11, 0, 0, // 0166 Tbar
  129, 102, 8, 0xfe, 0xe0, 0x23, 0xa2, 0x7, 0x90, 0x22, 0x35,
  4, 4, 10, 0, 0, // 0167 tbar
  129, 103, 8, 0x10, 0x1b, 0xfe, 0x4f, 0x1, 0x1, 0x43, 0x0,
  10, 8, 14, 1, 0, // 0168 Utilde
  129, 104, 8, 0x6, 0x82, 0xce, 0x20, 0x63, 0x44, 0x20, 0xf0,
  7, 6, 11, 1, 0, // 0169 utilde
  129, 105, 8, 0xd, 0x5, 0x8e, 0x21, 0x21, 0x33, 0x7, 0x40,
  10, 8, 13, 1, 0, // 016a Umacron
  129, 106, 7, 0xf, 0x38, 0x81, 0x8d, 0x10, 0x83, 0xc0,
  7, 6, 10, 1, 0, // 016b umacron
  129, 107, 7, 0x1e, 0x38, 0x84, 0x84, 0xcc, 0x1d, 0x0,
  10, 8, 14, 1, 0, // 016c Ubreve
  129, 108, 8, 0x8, 0x81, 0xce, 0x20, 0x63, 0x44, 0x20, 0xf0,
  7, 6, 11, 1, 0, // 016d ubreve
  129, 109, 8, 0x11, 0x3, 0x8e, 0x21, 0x21, 0x33, 0x7, 0x40,
  10, 8, 15, 1, 0, // 016e Uring
  129, 110, 9, 0x6, 0x2, 0x40, 0x63, 0x88, 0x18, 0xd1, 0x8, 0x3c,
  7, 6, 12, 1, 0, // 016f uring
  129, 111, 9, 0xc, 0x4, 0x80, 0xc3, 0x88, 0x48, 0x4c, 0xc1, 0xd0,
  10, 8, 15, 1, 0, // 0170 Uhungarumlaut
  129, 112, 8, 0x2, 0xb3, 0x38, 0x81, 0x8d, 0x10, 0x83, 0xc0,
  7, 6, 12, 1, 0, // 0171 uhungarumlaut
  129, 113, 8, 0x5, 0x33, 0x38, 0x84, 0x84, 0xcc, 0x1d, 0x0,
  10, 8, 14, 1, 253, // 0172 Uogonek
  129, 114, 8, 0x20, 0x63, 0x44, 0x20, 0xf0, 0x8, 0xc0, 0x70,
  7, 6, 11, 1, 253, // 0173 uogonek
  129, 115, 8, 0x21, 0x21, 0x33, 0x7, 0x40, 0x43, 0x3, 0x80,
  13, 13, 14, 0, 0, // 0174 Wcircumflex
  129, 116, 16, 0x0, 0x90, 0x15, 0xe4, 0x82, 0x2, 0x14, 0x85, 0x44, 0x5c, 0x80, 0x28, 0x28, 0x20, 0xfb, 0x14,
  10, 9, 11, 0, 0, // 0175 wcircumflex
  129, 117, 13, 0x2, 0x10, 0x51, 0xe4, 0x88, 0xba, 0x1, 0x27, 0x94, 0x55, 0x42, 0x25, 0x40,
  9, 9, 14, 0, 0, // 0176 Ycircumflex
  129, 118, 15, 0x2, 0x10, 0x51, 0xe6, 0xeb, 0x8c, 0x14, 0x41, 0xe0, 0x89, 0x50, 0x51, 0x7, 0x1f, 0xa3,
  7, 7, 14, 0, 253, // 0177 ycircumflex
  129, 119, 13, 0x4, 0x2, 0x8e, 0x20, 0x8c, 0x21, 0x11, 0x9, 0x2, 0x80, 0x63, 0xd7, 0x70,
  9, 7, 11, 1, 0, // 0178 Ydieresis
  129, 120, 8, 0x1b, 0x39, 0x20, 0x84, 0x44, 0x28, 0xf9, 0x50,
  9, 7, 14, 1, 0, // 0179 Zacute
  129, 121, 11, 0x2, 0x33, 0x8f, 0xe0, 0xb, 0x33, 0x7d, 0xcd, 0xf7, 0xf, 0xe0,
  7, 6, 11, 0, 0, // 017a zacute
  129, 122, 9, 0x2, 0x33, 0x8f, 0xc0, 0x13, 0x33, 0x33, 0xf, 0xc0,
  9, 7, 13, 1, 0, // 017b Zdotaccent
  129, 123, 10, 0x6, 0x38, 0xfe, 0x0, 0xb3, 0x37, 0xdc, 0xdf, 0x70, 0xfe,
  7, 6, 10, 0, 0, // 017c zdotaccent
  129, 124, 8, 0xc, 0x38, 0xfc, 0x1, 0x33, 0x33, 0x30, 0xfc,
  9, 7, 11, 1, 0, // 017d Zcaron
  129, 125, 9, 0xa, 0x3e, 0xe1, 0xf8, 0x4, 0xcc, 0xcc, 0xc3, 0xf8,
  7, 6, 11, 0, 0, // 017e zcaron
  129, 126, 9, 0x14, 0x3e, 0xe3, 0xf0, 0x4, 0xcc, 0xcc, 0xc3, 0xf0,
  0xff]

/**
The characters from the Latin Extended-B Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Latin_Extended-B )
This block has 208 assigned code points, and 110 of
  them are present in this font.
  This block contains characters in the range 0x0180-0x024f.
  The bitmaps for this block in this font take up about 2361 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
LATIN_EXTENDED_B ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0x39, 0x9, 0x0, 0x0, // Length 2361.
  0x54, 0x49, 0xe8, 0x7f, 0xe9, 0x20, 0x59, 0xb9, 0x29, 0xca, 0xd2, 0x39, 0xd5, 0x68, 0x84, 0xea, 0xfe, 0x49, 0x6e, 0x3f, 0x26, 0xc8, 0x5a, 0x46, 0x9c, 0x3c, 0x14, 0x4b, 0x28, 0xfa, 0x9d, 0x97, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x80, 0x1, 0x0, // Unicode range start 0x000180.
  116, 0x4f, 0x2, 0x0, // Unicode range end 0x00024f.
  0,
  10, 8, 11, 1, 0, // 0186 uni0186
  129, 134, 9, 0xe, 0xc, 0x62, 0xa, 0xd8, 0x8, 0x23, 0x18, 0x38,
  10, 9, 11, 0, 0, // 0189 uni0189
  129, 137, 16, 0x1f, 0x11, 0xd, 0x10, 0x51, 0x2, 0xe5, 0x3c, 0x11, 0x1, 0x51, 0x7, 0x84, 0x34, 0x7c, 0x40,
  9, 7, 11, 1, 0, // 018e uni018E
  129, 142, 8, 0x3f, 0x80, 0x25, 0x47, 0xe0, 0x9, 0x53, 0xf8,
  8, 8, 13, 0, 253, // 0192 florin
  129, 146, 9, 0x1, 0xc0, 0x84, 0x7e, 0x4, 0x20, 0xc5, 0x30, 0x0,
  4, 4, 11, 1, 0, // 0197 uni0197
  129, 151, 6, 0x10, 0x20, 0x3c, 0x4, 0x8, 0x0,
  3, 4, 11, 0, 0, // 019a uni019A
  129, 154, 6, 0x10, 0x20, 0x3c, 0x4, 0x8, 0x0,
  10, 10, 14, 255, 253, // 019d uni019D
  129, 157, 16, 0xc, 0x4, 0x0, 0xa1, 0x50, 0x91, 0x50, 0x89, 0x50, 0x85, 0x50, 0x83, 0x55, 0xe5, 0x30, 0x10,
  11, 9, 11, 1, 0, // 019f uni019F
  129, 159, 14, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x5f, 0xdb, 0x95, 0x10, 0x78, 0x63, 0x41, 0xc4,
  11, 10, 11, 1, 0, // 01a0 Ohorn
  129, 160, 13, 0x7, 0xc, 0x1, 0x8f, 0xc1, 0x7, 0x2e, 0x8d, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  8, 8, 8, 1, 0, // 01a1 ohorn
  129, 161, 8, 0x1e, 0xcc, 0xd2, 0x18, 0x84, 0x53, 0x30, 0x78,
  9, 7, 11, 1, 0, // 01a7 uni01A7
  129, 167, 13, 0xe, 0xc, 0x62, 0x8, 0x2, 0x3, 0x3, 0x3, 0x3, 0x8, 0x23, 0x18, 0x38,
  7, 5, 8, 1, 0, // 01a8 uni01A8
  129, 168, 10, 0x1c, 0x8, 0x80, 0x60, 0x70, 0x30, 0x30, 0x88, 0x1c, 0x0,
  9, 9, 14, 0, 253, // 01ae uni01AE
  129, 174, 6, 0xfe, 0xe0, 0x23, 0xac, 0xc0, 0x19,
  10, 10, 11, 1, 0, // 01af Uhorn
  129, 175, 10, 0x20, 0x4c, 0x7, 0xc7, 0x1e, 0xb0, 0x4, 0x24, 0x3c, 0x40,
  7, 8, 8, 1, 0, // 01b0 uhorn
  129, 176, 8, 0x21, 0xc8, 0x52, 0x18, 0x84, 0x53, 0x30, 0x74,
  9, 7, 11, 1, 0, // 01b5 uni01B5
  129, 181, 9, 0x3f, 0x80, 0x2c, 0xcd, 0xbc, 0x20, 0xdf, 0x70, 0xfe,
  7, 6, 8, 0, 0, // 01b6 uni01B6
  129, 182, 8, 0x3f, 0x0, 0x4c, 0x1e, 0x2, 0xc, 0xc3, 0xf0,
  8, 6, 11, 1, 0, // 01bb uni01BB
  129, 187, 10, 0x1e, 0x8, 0x44, 0x4, 0xc3, 0xf0, 0x20, 0xcc, 0x4f, 0xc0,
  8, 6, 11, 1, 0, // 01bc uni01BC
  129, 188, 9, 0x3f, 0x2e, 0x53, 0xe0, 0x4, 0x52, 0x11, 0x1e, 0x0,
  3, 1, 14, 1, 253, // 01c0 uni01C0
  129, 192, 2, 0xba, 0xc3,
  9, 6, 14, 1, 254, // 01c2 uni01C2
  129, 194, 8, 0x4, 0x21, 0x3f, 0x1, 0x3, 0xf0, 0x10, 0x80,
  4, 1, 11, 2, 0, // 01c3 uni01C3
  129, 195, 3, 0xba, 0x3e, 0xb9,
  9, 9, 14, 0, 0, // 01cd uni01CD
  129, 205, 17, 0x5, 0x1f, 0x9e, 0x40, 0x86, 0xf4, 0x14, 0x54, 0x22, 0x54, 0x41, 0x47, 0xf4, 0x41, 0x6e, 0xb9, 0x40,
  8, 7, 11, 1, 0, // 01ce uni01CE
  129, 206, 13, 0xa, 0x3e, 0xe1, 0xe0, 0xcc, 0x1, 0x7, 0xc3, 0x10, 0x84, 0x33, 0x7, 0x60,
  4, 3, 14, 1, 0, // 01cf uni01CF
  129, 207, 5, 0x28, 0x33, 0x84, 0xb, 0x0,
  3, 3, 11, 0, 0, // 01d0 uni01D0
  129, 208, 5, 0x28, 0x33, 0x84, 0x8, 0xc0,
  11, 9, 14, 1, 0, // 01d1 uni01D1
  129, 209, 15, 0x5, 0x1f, 0x9e, 0x41, 0xc4, 0x63, 0x44, 0x16, 0xeb, 0xa3, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  8, 6, 11, 1, 0, // 01d2 uni01D2
  129, 210, 10, 0xa, 0x3e, 0xe1, 0xe0, 0xcc, 0x21, 0x15, 0x33, 0x7, 0x80,
  10, 8, 14, 1, 0, // 01d3 uni01D3
  129, 211, 8, 0x5, 0x3e, 0xe2, 0x6, 0x34, 0x42, 0xf, 0x0,
  7, 6, 11, 1, 0, // 01d4 uni01D4
  129, 212, 7, 0xa, 0x3e, 0xe2, 0x12, 0x13, 0x30, 0x74,
  10, 8, 15, 1, 0, // 01d5 uni01D5
  129, 213, 9, 0xf, 0x38, 0x66, 0xe2, 0x6, 0x34, 0x42, 0xf, 0x0,
  8, 6, 13, 1, 0, // 01d6 uni01D6
  129, 214, 9, 0x1e, 0x38, 0x48, 0x78, 0x84, 0x84, 0xcc, 0x1d, 0x0,
  10, 8, 16, 1, 0, // 01d7 uni01D7
  129, 215, 9, 0x2, 0x33, 0x86, 0x6e, 0x20, 0x63, 0x44, 0x20, 0xf0,
  8, 6, 14, 1, 0, // 01d8 uni01D8
  129, 216, 9, 0x4, 0x33, 0x84, 0x87, 0x88, 0x48, 0x4c, 0xc1, 0xd0,
  10, 8, 16, 1, 0, // 01d9 uni01D9
  129, 217, 9, 0x5, 0x3e, 0xe1, 0x9b, 0x88, 0x18, 0xd1, 0x8, 0x3c,
  8, 6, 14, 1, 0, // 01da uni01DA
  129, 218, 9, 0xa, 0x3e, 0xe1, 0x21, 0xe2, 0x12, 0x13, 0x30, 0x74,
  10, 8, 16, 1, 0, // 01db uni01DB
  129, 219, 9, 0x4, 0x2b, 0x86, 0x6e, 0x20, 0x63, 0x44, 0x20, 0xf0,
  8, 6, 14, 1, 0, // 01dc uni01DC
  129, 220, 9, 0x8, 0x2b, 0x84, 0x87, 0x88, 0x48, 0x4c, 0xc1, 0xd0,
  8, 6, 8, 1, 0, // 01dd uni01DD
  129, 221, 9, 0x1e, 0xc, 0xc0, 0x11, 0x3f, 0x8, 0x43, 0x30, 0x78,
  9, 9, 15, 0, 0, // 01de uni01DE
  129, 222, 18, 0x7, 0x9e, 0x43, 0x67, 0x90, 0x21, 0xbd, 0x5, 0x15, 0x8, 0x95, 0x10, 0x51, 0xfd, 0x10, 0x5b, 0xae, 0x50,
  8, 7, 13, 1, 0, // 01df uni01DF
  129, 223, 14, 0x1e, 0x38, 0x48, 0x78, 0x78, 0x33, 0x0, 0x41, 0xf0, 0xc4, 0x21, 0xc, 0xc1, 0xd8,
  9, 9, 15, 0, 0, // 01e0 uni01E0
  129, 224, 18, 0x7, 0x9e, 0x40, 0xc7, 0x90, 0x21, 0xbd, 0x5, 0x15, 0x8, 0x95, 0x10, 0x51, 0xfd, 0x10, 0x5b, 0xae, 0x50,
  8, 7, 12, 1, 0, // 01e1 uni01E1
  129, 225, 14, 0x1e, 0x38, 0x30, 0xe1, 0xe0, 0xcc, 0x1, 0x7, 0xc3, 0x10, 0x84, 0x33, 0x7, 0x60,
  14, 12, 13, 1, 0, // 01e2 uni01E2
  129, 226, 20, 0x3, 0xde, 0x41, 0xf3, 0xc0, 0x12, 0xe5, 0x8, 0x95, 0x8, 0xcf, 0x1, 0xfb, 0x84, 0x25, 0x48, 0x24, 0x83, 0x3c, 0x0,
  13, 11, 10, 1, 0, // 01e3 uni01E3
  129, 227, 18, 0x3, 0xde, 0x47, 0xb3, 0x0, 0xc6, 0xa0, 0x13, 0xc1, 0xfc, 0xe0, 0x31, 0x38, 0x84, 0x6f, 0x18, 0x7, 0xbc,
  11, 9, 11, 1, 0, // 01e4 uni01E4
  129, 228, 15, 0x7, 0x91, 0x86, 0xef, 0x5c, 0xe5, 0x21, 0xee, 0xb9, 0x21, 0xd1, 0x1, 0x18, 0xd0, 0x71,
  8, 6, 11, 1, 253, // 01e5 uni01E5
  129, 229, 10, 0x1d, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x74, 0xd3, 0x30, 0x78,
  11, 9, 14, 1, 0, // 01e6 Gcaron
  129, 230, 17, 0x5, 0x1f, 0x9e, 0x41, 0xe4, 0x61, 0xbb, 0xd7, 0x39, 0x48, 0x7b, 0xae, 0x56, 0x91, 0x8d, 0x7, 0x10,
  8, 6, 14, 1, 253, // 01e7 gcaron
  129, 231, 14, 0xa, 0x3e, 0xe1, 0xd0, 0xcc, 0x21, 0x15, 0x33, 0x7, 0x40, 0x10, 0xcc, 0x1e, 0x0,
  9, 8, 14, 1, 0, // 01e8 uni01E8
  129, 232, 16, 0xa, 0x3e, 0xe2, 0x8, 0x84, 0x22, 0x9, 0x2, 0x83, 0x49, 0x2, 0x20, 0x84, 0x20, 0x88, 0x10,
  7, 6, 14, 1, 0, // 01e9 uni01E9
  129, 233, 14, 0x28, 0x33, 0xae, 0x52, 0x20, 0x90, 0x28, 0xc, 0x2, 0x80, 0x90, 0x22, 0x8, 0x40,
  11, 9, 14, 1, 253, // 01ea uni01EA
  129, 234, 15, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x8d, 0x10, 0x78, 0x63, 0x41, 0xc7, 0xe7, 0x10, 0x71,
  8, 6, 11, 1, 253, // 01eb uni01EB
  129, 235, 10, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78, 0x4, 0x30, 0x38,
  11, 9, 16, 1, 253, // 01ec uni01EC
  129, 236, 18, 0x7, 0x9e, 0x41, 0xc4, 0x63, 0x44, 0x16, 0xeb, 0xa3, 0x44, 0x1e, 0x18, 0xd0, 0x71, 0xf9, 0xc4, 0x1c, 0x40,
  8, 6, 13, 1, 253, // 01ed uni01ED
  129, 237, 12, 0x1e, 0x38, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0, 0x10, 0xc0, 0xe0,
  3, 4, 14, 255, 253, // 01f0 uni01F0
  129, 240, 7, 0x14, 0x3e, 0xe0, 0x82, 0x35, 0x30, 0x0,
  11, 9, 14, 1, 0, // 01f4 uni01F4
  129, 244, 17, 0x1, 0x1c, 0x79, 0x7, 0x91, 0x86, 0xef, 0x5c, 0xe5, 0x21, 0xee, 0xb9, 0x5a, 0x46, 0x34, 0x1c, 0x40,
  8, 6, 14, 1, 253, // 01f5 uni01F5
  129, 245, 13, 0x4, 0x33, 0x87, 0x43, 0x30, 0x84, 0x54, 0xcc, 0x1d, 0x0, 0x43, 0x30, 0x78,
  10, 8, 14, 1, 0, // 01f8 uni01F8
  129, 248, 11, 0x8, 0x2b, 0x8c, 0x12, 0x85, 0x24, 0x52, 0x25, 0x21, 0x52, 0xd,
  8, 6, 11, 1, 0, // 01f9 uni01F9
  129, 249, 7, 0x8, 0x2b, 0x8b, 0x83, 0x30, 0x84, 0x84,
  9, 9, 17, 0, 0, // 01fa Aringacute
  129, 250, 19, 0x1, 0x1c, 0x79, 0x3, 0x10, 0x49, 0x50, 0x31, 0x50, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5,
  8, 7, 15, 1, 0, // 01fb aringacute
  129, 251, 17, 0x2, 0x33, 0x83, 0x1, 0x20, 0x30, 0xe1, 0xe0, 0xcc, 0x1, 0x7, 0xc3, 0x10, 0x84, 0x33, 0x7, 0x60,
  14, 12, 14, 1, 0, // 01fc AEacute
  129, 252, 20, 0xb5, 0xc7, 0x90, 0x7c, 0xf0, 0x4, 0xb9, 0x42, 0x25, 0x42, 0x33, 0xc0, 0x7e, 0xe1, 0x9, 0x52, 0x9, 0x20, 0xcf, 0x0,
  13, 11, 11, 1, 0, // 01fd aeacute
  129, 253, 19, 0x0, 0x9c, 0x79, 0x1e, 0xcc, 0x3, 0x1a, 0x80, 0x4f, 0x7, 0xf3, 0x80, 0xc4, 0xe2, 0x11, 0xbc, 0x60, 0x1e, 0xf0,
  11, 11, 14, 0, 0, // 01fe Oslashacute
  129, 254, 22, 0x0, 0x9c, 0x79, 0x3, 0x82, 0x0, 0xc4, 0xc0, 0xf7, 0x4, 0x1a, 0x10, 0x91, 0x11, 0x12, 0x11, 0x41, 0xfb, 0x7, 0x14, 0x8e, 0xe0,
  8, 8, 11, 0, 0, // 01ff oslashacute
  129, 255, 13, 0x1, 0x33, 0x83, 0xd1, 0x88, 0x46, 0x12, 0x85, 0x21, 0x88, 0x46, 0x2f, 0x0,
  9, 9, 15, 0, 0, // 0200 uni0200
  130, 0, 17, 0x14, 0x1a, 0x69, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  8, 7, 12, 1, 0, // 0201 uni0201
  130, 1, 13, 0x28, 0x2a, 0xb8, 0x78, 0x33, 0x0, 0x41, 0xf0, 0xc4, 0x21, 0xc, 0xc1, 0xd8,
  9, 9, 14, 0, 0, // 0202 uni0202
  130, 2, 17, 0x7, 0x10, 0x89, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  8, 7, 11, 1, 0, // 0203 uni0203
  130, 3, 13, 0xe, 0x4, 0x4e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76,
  9, 7, 15, 1, 0, // 0204 uni0204
  130, 4, 10, 0x28, 0x2a, 0xb8, 0xfe, 0xb9, 0x53, 0xf2, 0xe5, 0x4f, 0xe0,
  8, 6, 12, 1, 0, // 0205 uni0205
  130, 5, 12, 0x28, 0x2a, 0xb8, 0x78, 0x33, 0x8, 0x43, 0xf2, 0xe4, 0xcc, 0x1e, 0x0,
  9, 7, 14, 1, 0, // 0206 uni0206
  130, 6, 10, 0xe, 0x4, 0x4e, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8,
  8, 6, 11, 1, 0, // 0207 uni0207
  130, 7, 12, 0xe, 0x4, 0x4e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  4, 5, 15, 255, 0, // 0208 uni0208
  130, 8, 6, 0x28, 0x2a, 0xb8, 0x10, 0xb0, 0x0,
  3, 5, 12, 254, 0, // 0209 uni0209
  130, 9, 5, 0x28, 0x2a, 0xb8, 0x10, 0x8c,
  4, 5, 14, 0, 0, // 020a uni020A
  130, 10, 6, 0x1c, 0x8, 0x8e, 0x8, 0x2c, 0x0,
  3, 5, 11, 255, 0, // 020b uni020B
  130, 11, 5, 0x1c, 0x8, 0x8e, 0x8, 0x23,
  11, 9, 15, 1, 0, // 020c uni020C
  130, 12, 16, 0x14, 0x1a, 0x69, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  8, 6, 12, 1, 0, // 020d uni020D
  130, 13, 10, 0x28, 0x2a, 0xb8, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0,
  11, 9, 14, 1, 0, // 020e uni020E
  130, 14, 16, 0x7, 0x10, 0x89, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  8, 6, 11, 1, 0, // 020f uni020F
  130, 15, 10, 0xe, 0x4, 0x4e, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  10, 8, 15, 1, 0, // 0210 uni0210
  130, 16, 13, 0x14, 0x2a, 0xb8, 0xfe, 0x20, 0xc8, 0x14, 0x82, 0x3f, 0x8, 0x22, 0x5, 0x50,
  5, 5, 12, 0, 0, // 0211 uni0211
  130, 17, 7, 0x28, 0x2a, 0xb8, 0x58, 0x18, 0x3d, 0x84,
  10, 8, 14, 1, 0, // 0212 uni0212
  130, 18, 13, 0xe, 0x4, 0x4e, 0x3f, 0x88, 0x32, 0x5, 0x20, 0x8f, 0xc2, 0x8, 0x81, 0x54,
  5, 5, 11, 0, 0, // 0213 uni0213
  130, 19, 7, 0x1c, 0x8, 0x8e, 0x16, 0x6, 0xf, 0x61,
  10, 8, 15, 1, 0, // 0214 uni0214
  130, 20, 8, 0x14, 0x2a, 0xb8, 0x81, 0x8d, 0x10, 0x83, 0xc0,
  7, 6, 12, 1, 0, // 0215 uni0215
  130, 21, 8, 0x28, 0x2a, 0xb8, 0x84, 0x84, 0xcc, 0x1d, 0x0,
  10, 8, 14, 1, 0, // 0216 uni0216
  130, 22, 8, 0x7, 0x2, 0x2e, 0x20, 0x63, 0x44, 0x20, 0xf0,
  7, 6, 11, 1, 0, // 0217 uni0217
  130, 23, 8, 0xe, 0x4, 0x4e, 0x21, 0x21, 0x33, 0x7, 0x40,
  9, 7, 16, 1, 251, // 0218 Scommaaccent
  130, 24, 16, 0xe, 0xc, 0x62, 0xa, 0xe1, 0x80, 0x18, 0x1, 0xbc, 0x20, 0x8c, 0x60, 0xe3, 0x81, 0x5, 0xc0,
  7, 5, 13, 1, 251, // 0219 scommaaccent
  130, 25, 13, 0x1c, 0x8, 0x83, 0x0, 0x70, 0x6, 0x3c, 0x22, 0x7, 0xe, 0x8, 0x17, 0x0,
  9, 9, 16, 0, 251, // 021a Tcommaaccent
  130, 26, 8, 0xfe, 0xe0, 0x23, 0xac, 0x8e, 0x40, 0x88, 0x71,
  4, 4, 15, 0, 251, // 021b tcommaaccent
  130, 27, 8, 0x10, 0x1b, 0xfe, 0x84, 0x30, 0xe0, 0x81, 0x70,
  10, 8, 14, 1, 0, // 021e uni021E
  130, 30, 8, 0x5, 0x3e, 0xe2, 0x6, 0xf, 0xc8, 0x18, 0x0,
  8, 6, 14, 1, 0, // 021f uni021F
  130, 31, 8, 0x28, 0x33, 0xae, 0x52, 0xe0, 0xcc, 0x21, 0x21,
  9, 9, 13, 0, 0, // 0226 uni0226
  130, 38, 16, 0x3, 0x1e, 0x40, 0x86, 0xf4, 0x14, 0x54, 0x22, 0x54, 0x41, 0x47, 0xf4, 0x41, 0x6e, 0xb9, 0x40,
  8, 7, 10, 1, 0, // 0227 uni0227
  130, 39, 12, 0xc, 0x38, 0x78, 0x33, 0x0, 0x41, 0xf0, 0xc4, 0x21, 0xc, 0xc1, 0xd8,
  9, 7, 14, 1, 253, // 0228 uni0228
  130, 40, 11, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8, 0x10, 0x12, 0x3, 0x0,
  8, 6, 11, 1, 253, // 0229 uni0229
  130, 41, 13, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80, 0x80, 0x90, 0x18, 0x0,
  11, 9, 15, 1, 0, // 022a uni022A
  130, 42, 17, 0x7, 0x9e, 0x43, 0x37, 0x90, 0x71, 0x18, 0xd1, 0x5, 0xba, 0xe8, 0xd1, 0x7, 0x86, 0x34, 0x1c, 0x40,
  8, 6, 13, 1, 0, // 022b uni022B
  130, 43, 11, 0x1e, 0x38, 0x48, 0x78, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0,
  11, 9, 16, 1, 0, // 022c uni022C
  130, 44, 18, 0x7, 0x9e, 0x41, 0xa4, 0x2c, 0x79, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x8d, 0x10, 0x78, 0x63, 0x41, 0xc4,
  8, 6, 13, 1, 0, // 022d uni022D
  130, 45, 12, 0x1e, 0x38, 0x68, 0x2c, 0x38, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0,
  11, 9, 13, 1, 0, // 022e uni022E
  130, 46, 14, 0x3, 0x1e, 0x41, 0xc4, 0x63, 0x44, 0x16, 0xeb, 0xa3, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  8, 6, 10, 1, 0, // 022f uni022F
  130, 47, 9, 0xc, 0x38, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0,
  11, 9, 15, 1, 0, // 0230 uni0230
  130, 48, 17, 0x7, 0x9e, 0x40, 0xc7, 0x90, 0x71, 0x18, 0xd1, 0x5, 0xba, 0xe8, 0xd1, 0x7, 0x86, 0x34, 0x1c, 0x40,
  8, 6, 12, 1, 0, // 0231 uni0231
  130, 49, 11, 0x1e, 0x38, 0x30, 0xe1, 0xe0, 0xcc, 0x21, 0x15, 0x33, 0x7, 0x80,
  9, 9, 13, 0, 0, // 0232 uni0232
  130, 50, 14, 0x7, 0x9e, 0x6e, 0xb8, 0xc1, 0x44, 0x1e, 0x8, 0x95, 0x5, 0x10, 0x71, 0xfa, 0x30,
  7, 7, 13, 0, 253, // 0233 uni0233
  130, 51, 12, 0x1e, 0x38, 0x82, 0x30, 0x84, 0x44, 0x24, 0xa, 0x1, 0x8f, 0x5d, 0xc0,
  0xff]

/**
The characters from the IPA Extensions Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/IPA_Extensions )
This block has 96 assigned code points, but only 15 of
  them are present in this font.
  This block contains characters in the range 0x0250-0x02af.
  The bitmaps for this block in this font take up about 449 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
IPA_EXTENSIONS ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0xc1, 0x1, 0x0, 0x0, // Length 449.
  0x54, 0x8a, 0x1c, 0x47, 0x4b, 0x90, 0xb5, 0x93, 0xed, 0x89, 0x45, 0x27, 0xa8, 0x9b, 0x6e, 0x4d, 0x1, 0xde, 0x97, 0x4d, 0x68, 0x77, 0xff, 0x7f, 0x4d, 0xee, 0x4f, 0x51, 0x24, 0xff, 0x67, 0x9f, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x50, 0x2, 0x0, // Unicode range start 0x000250.
  116, 0xaf, 0x2, 0x0, // Unicode range end 0x0002af.
  0,
  8, 7, 8, 1, 0, // 0250 uni0250
  130, 80, 10, 0x37, 0x6, 0x61, 0x8, 0x46, 0x1f, 0x4, 0x1, 0x98, 0x3c,
  7, 6, 8, 1, 0, // 0254 uni0254
  130, 84, 8, 0x1e, 0xc, 0xc0, 0x11, 0x48, 0x43, 0x30, 0x78,
  8, 6, 8, 1, 0, // 0258 uni0258
  130, 88, 9, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0x1, 0x13, 0x30, 0x78,
  8, 6, 8, 1, 0, // 0259 uni0259
  130, 89, 9, 0x1e, 0xc, 0xc0, 0x11, 0x3f, 0x8, 0x43, 0x30, 0x78,
  4, 4, 11, 0, 253, // 025f uni025F
  130, 95, 5, 0x8, 0x22, 0xbf, 0xe4, 0xc0,
  8, 6, 11, 1, 253, // 0265 uni0265
  130, 101, 7, 0x21, 0x21, 0x33, 0x7, 0x40, 0x11, 0x40,
  8, 6, 8, 1, 0, // 0275 uni0275
  130, 117, 9, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0x21, 0x13, 0x30, 0x78,
  5, 4, 8, 1, 0, // 0279 uni0279
  130, 121, 4, 0x4, 0x21, 0xd3, 0x40,
  4, 4, 10, 0, 0, // 0287 uni0287
  130, 135, 5, 0x30, 0x2, 0x8, 0x6f, 0xf9,
  4, 4, 13, 0, 253, // 0288 uni0288
  130, 136, 6, 0x10, 0x1b, 0xfe, 0x8d, 0xc, 0x0,
  7, 6, 8, 1, 0, // 0289 uni0289
  130, 137, 7, 0x21, 0x14, 0xfc, 0x21, 0x13, 0x30, 0x74,
  7, 7, 8, 0, 0, // 028c uni028C
  130, 140, 6, 0x4, 0x2, 0x84, 0x44, 0x52, 0x9,
  10, 9, 8, 0, 0, // 028d uni028D
  130, 141, 9, 0x8, 0x95, 0x15, 0x51, 0x25, 0x52, 0x22, 0xe8, 0x0,
  7, 7, 11, 0, 0, // 028e uni028E
  130, 142, 10, 0x3, 0x33, 0xd7, 0x42, 0x81, 0x20, 0x44, 0x48, 0x62, 0x8,
  7, 6, 11, 1, 253, // 029e uni029E
  130, 158, 12, 0x21, 0x4, 0x40, 0x90, 0x14, 0x3, 0x1, 0x40, 0x90, 0x44, 0x1, 0x14,
  0xff]

/**
The characters from the Spacing Modifier Letters Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Spacing_Modifier_Letters )
This block has 80 assigned code points, but only 19 of
  them are present in this font.
  This block contains characters in the range 0x02b0-0x02ff.
  The bitmaps for this block in this font take up about 414 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
SPACING_MODIFIER_LETTERS ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0x9e, 0x1, 0x0, 0x0, // Length 414.
  0x91, 0xce, 0xc2, 0xcf, 0x1, 0xe1, 0xe6, 0xd7, 0x3c, 0xab, 0xc7, 0xf3, 0x9b, 0x39, 0xa, 0xe, 0xca, 0xf5, 0xd1, 0xb1, 0x49, 0xa7, 0x6f, 0xfc, 0xb2, 0xa0, 0x35, 0x59, 0xe, 0xf3, 0x6, 0x8c, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0xb0, 0x2, 0x0, // Unicode range start 0x0002b0.
  116, 0xff, 0x2, 0x0, // Unicode range end 0x0002ff.
  0,
  3, 2, 3, 0, 8, // 02bb uni02BB
  130, 187, 3, 0x10, 0x32, 0x40,
  3, 2, 3, 1, 8, // 02bc afii57929
  130, 188, 3, 0x30, 0x3c, 0xc0,
  3, 2, 3, 1, 8, // 02bd afii64937
  130, 189, 3, 0x30, 0x32, 0x80,
  5, 3, 2, 1, 9, // 02c6 circumflex
  130, 198, 3, 0x10, 0xa, 0x0,
  5, 3, 2, 1, 9, // 02c7 caron
  130, 199, 2, 0x28, 0x30,
  3, 1, 3, 1, 8, // 02c8 uni02C8
  130, 200, 2, 0xb9, 0x40,
  4, 4, 1, 0, 9, // 02c9 macron
  130, 201, 2, 0x3c, 0x0,
  5, 2, 2, 2, 9, // 02ca uni02CA
  130, 202, 2, 0x10, 0x30,
  5, 2, 2, 1, 9, // 02cb uni02CB
  130, 203, 2, 0xba, 0x80,
  4, 4, 1, 0, 254, // 02cd uni02CD
  130, 205, 2, 0x3c, 0x0,
  5, 2, 2, 1, 253, // 02ce uni02CE
  130, 206, 2, 0xba, 0x80,
  5, 2, 2, 2, 253, // 02cf uni02CF
  130, 207, 2, 0x10, 0x30,
  5, 5, 2, 0, 9, // 02d8 breve
  130, 216, 3, 0x22, 0x7, 0x0,
  4, 2, 1, 1, 9, // 02d9 dotaccent
  130, 217, 2, 0x30, 0x0,
  5, 4, 3, 0, 8, // 02da ring
  130, 218, 4, 0x18, 0x9, 0x1, 0x80,
  5, 3, 3, 2, 253, // 02db ogonek
  130, 219, 3, 0x10, 0x30, 0xe0,
  5, 5, 2, 0, 9, // 02dc tilde
  130, 220, 3, 0x1a, 0xb, 0x0,
  5, 5, 3, 0, 8, // 02dd hungarumlaut
  130, 221, 3, 0xa, 0x33, 0x0,
  6, 5, 3, 1, 8, // 02ee uni02EE
  130, 238, 3, 0x36, 0x3c, 0xc0,
  0xff]

/**
The characters from the Greek and Coptic Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Greek_and_Coptic )
This block has 135 assigned code points, but only 5 of
  them are present in this font:
  Greek question mark (;),
  tonos,
  dieresistonos,
  anoteleia, and
  mu.
  This block contains characters in the range 0x0370-0x03ff.
  The bitmaps for this block in this font take up about 272 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
GREEK_AND_COPTIC ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0x10, 0x1, 0x0, 0x0, // Length 272.
  0x80, 0x6e, 0xb8, 0x43, 0x54, 0xb2, 0x7c, 0xf0, 0x1, 0x65, 0xaa, 0x0, 0x17, 0xae, 0xc7, 0x67, 0xb9, 0xf5, 0xc9, 0xc0, 0xb3, 0x46, 0xeb, 0xec, 0x2f, 0xf5, 0x2a, 0x9e, 0x6d, 0xef, 0xed, 0x85, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x70, 0x3, 0x0, // Unicode range start 0x000370.
  116, 0xff, 0x3, 0x0, // Unicode range end 0x0003ff.
  0,
  4, 2, 10, 0, 254, // 037e uni037E
  131, 126, 5, 0x10, 0x1e, 0x54, 0x40, 0x5c,
  5, 2, 2, 2, 9, // 0384 tonos
  131, 132, 2, 0x10, 0x30,
  5, 5, 4, 0, 9, // 0385 dieresistonos
  131, 133, 4, 0x4, 0x33, 0x8d, 0x80,
  4, 2, 1, 1, 4, // 0387 anoteleia
  131, 135, 2, 0x30, 0x0,
  8, 6, 11, 1, 253, // 03bc mu
  131, 188, 6, 0x21, 0x21, 0x33, 0xb, 0x4b, 0x94,
  0xff]

/**
The characters from the Latin Extended Additional Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Latin_Extended_Additional )
This block has 256 assigned code points, and 220 of
  them are present in this font.
  This block contains characters in the range 0x1e00-0x1eff.
  The bitmaps for this block in this font take up about 4574 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
LATIN_EXTENDED_ADDITIONAL ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0xde, 0x11, 0x0, 0x0, // Length 4574.
  0x12, 0x27, 0xbc, 0xdf, 0x70, 0x2e, 0xb4, 0xb6, 0x3c, 0x86, 0xc3, 0x0, 0xe8, 0x83, 0x90, 0x1c, 0x4a, 0x2a, 0x3e, 0x24, 0x8d, 0x91, 0xef, 0x60, 0xf4, 0xaa, 0xbd, 0x3, 0x9d, 0x3e, 0x71, 0x7c, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x0, 0x1e, 0x0, // Unicode range start 0x001e00.
  116, 0xff, 0x1e, 0x0, // Unicode range end 0x001eff.
  0,
  9, 9, 15, 0, 252, // 1e00 uni1E00
  158, 0, 19, 0x2, 0x1b, 0xd0, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5, 0xee, 0x3, 0x10, 0x49, 0x3, 0x10,
  8, 7, 12, 1, 252, // 1e01 uni1E01
  158, 1, 15, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76, 0xe0, 0xc0, 0x48, 0xc, 0x0,
  9, 7, 13, 1, 0, // 1e02 uni1E02
  158, 2, 13, 0xc, 0x38, 0xfc, 0x21, 0x88, 0x24, 0x84, 0x3e, 0x8, 0x42, 0x9, 0xd3, 0xf0,
  7, 6, 13, 1, 0, // 1e03 uni1E03
  158, 3, 10, 0x30, 0x3a, 0xe5, 0x2e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0xb8,
  9, 7, 13, 1, 254, // 1e04 uni1E04
  158, 4, 13, 0x3f, 0x8, 0x62, 0x9, 0x21, 0xf, 0x82, 0x10, 0x82, 0x74, 0xfc, 0xe0, 0xc0,
  7, 6, 13, 1, 254, // 1e05 uni1E05
  158, 5, 10, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x2e, 0x38, 0x30,
  9, 7, 13, 1, 254, // 1e06 uni1E06
  158, 6, 13, 0x3f, 0x8, 0x62, 0x9, 0x21, 0xf, 0x82, 0x10, 0x82, 0x74, 0xfc, 0xe1, 0xe0,
  7, 6, 13, 1, 254, // 1e07 uni1E07
  158, 7, 10, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x2e, 0x38, 0x78,
  10, 8, 17, 1, 253, // 1e08 uni1E08
  158, 8, 15, 0x2, 0x33, 0x81, 0xc1, 0x8c, 0x41, 0xba, 0x1, 0x4, 0x63, 0x7, 0x3e, 0x9, 0x1, 0x80,
  8, 6, 14, 1, 253, // 1e09 uni1E09
  158, 9, 14, 0x4, 0x33, 0x87, 0x83, 0x32, 0xe5, 0x21, 0xc, 0xc1, 0xe0, 0x10, 0x12, 0x3, 0x0,
  10, 8, 13, 1, 0, // 1e0a uni1E0A
  158, 10, 11, 0xc, 0x38, 0xf8, 0x21, 0x88, 0x22, 0x6, 0x2, 0xb, 0x4f, 0x80,
  8, 6, 13, 1, 0, // 1e0b uni1E0B
  158, 11, 11, 0x3, 0x38, 0x4, 0x51, 0xd0, 0xcc, 0x21, 0x15, 0x33, 0x7, 0x40,
  10, 8, 13, 1, 254, // 1e0c uni1E0C
  158, 12, 11, 0x3e, 0x8, 0x62, 0x8, 0x81, 0x80, 0x82, 0xd3, 0xe3, 0x83, 0x0,
  8, 6, 13, 1, 254, // 1e0d uni1E0D
  158, 13, 11, 0x1, 0x14, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd3, 0x83, 0x0,
  10, 8, 13, 1, 254, // 1e0e uni1E0E
  158, 14, 11, 0x3e, 0x8, 0x62, 0x8, 0x81, 0x80, 0x82, 0xd3, 0xe3, 0x87, 0x80,
  8, 6, 13, 1, 254, // 1e0f uni1E0F
  158, 15, 11, 0x1, 0x14, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd3, 0x87, 0x80,
  10, 8, 14, 1, 253, // 1e10 uni1E10
  158, 16, 13, 0x3e, 0x8, 0x62, 0x8, 0x81, 0x80, 0x82, 0xd3, 0xe0, 0x10, 0x12, 0x3, 0x0,
  8, 6, 14, 1, 253, // 1e11 uni1E11
  158, 17, 13, 0x1, 0x14, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd0, 0x10, 0x12, 0x3, 0x0,
  10, 8, 14, 1, 253, // 1e12 uni1E12
  158, 18, 12, 0x3e, 0x8, 0x62, 0x8, 0x81, 0x80, 0x82, 0xd3, 0xe3, 0x81, 0x0, 0xa0,
  8, 6, 14, 1, 253, // 1e13 uni1E13
  158, 19, 12, 0x1, 0x14, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd3, 0x81, 0x0, 0xa0,
  9, 7, 16, 1, 0, // 1e14 uni1E14
  158, 20, 11, 0x8, 0x2b, 0x87, 0x8e, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8,
  8, 6, 13, 1, 0, // 1e15 uni1E15
  158, 21, 13, 0x8, 0x2b, 0x87, 0x8e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  9, 7, 16, 1, 0, // 1e16 uni1E16
  158, 22, 11, 0x2, 0x33, 0x87, 0x8e, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8,
  8, 6, 13, 1, 0, // 1e17 uni1E17
  158, 23, 13, 0x4, 0x33, 0x87, 0x8e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  9, 7, 14, 1, 253, // 1e18 uni1E18
  158, 24, 10, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xfb, 0x81, 0x0, 0xa0,
  8, 6, 11, 1, 253, // 1e19 uni1E19
  158, 25, 12, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x8e, 0x8, 0x5, 0x0,
  9, 7, 14, 1, 253, // 1e1a uni1E1A
  158, 26, 10, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xfb, 0x86, 0x82, 0xc0,
  8, 6, 11, 1, 253, // 1e1b uni1E1B
  158, 27, 12, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x8e, 0x1a, 0xb, 0x0,
  9, 7, 17, 1, 253, // 1e1c uni1E1C
  158, 28, 14, 0x22, 0x7, 0xe, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8, 0x10, 0x12, 0x3, 0x0,
  8, 6, 14, 1, 253, // 1e1d uni1E1D
  158, 29, 16, 0x11, 0x3, 0x8e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80, 0x80, 0x90, 0x18, 0x0,
  8, 7, 13, 1, 0, // 1e1e uni1E1E
  158, 30, 8, 0xc, 0x38, 0xfe, 0xb9, 0x53, 0xf2, 0xe8, 0x0,
  4, 4, 13, 0, 0, // 1e1f uni1E1F
  158, 31, 7, 0x18, 0x38, 0x30, 0x10, 0x1b, 0xfe, 0x88,
  11, 9, 13, 1, 0, // 1e20 uni1E20
  158, 32, 16, 0x7, 0x9e, 0x41, 0xe4, 0x61, 0xbb, 0xd7, 0x39, 0x48, 0x7b, 0xae, 0x56, 0x91, 0x8d, 0x7, 0x10,
  8, 6, 13, 1, 253, // 1e21 uni1E21
  158, 33, 13, 0x1e, 0x38, 0x74, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xd0, 0x4, 0x33, 0x7, 0x80,
  10, 8, 13, 1, 0, // 1e22 uni1E22
  158, 34, 7, 0x6, 0x38, 0x81, 0x83, 0xf2, 0x6, 0x0,
  8, 6, 13, 1, 0, // 1e23 uni1E23
  158, 35, 8, 0x30, 0x3a, 0xe5, 0x2e, 0xc, 0xc2, 0x12, 0x10,
  10, 8, 13, 1, 254, // 1e24 uni1E24
  158, 36, 7, 0x20, 0x60, 0xfc, 0x81, 0x83, 0x81, 0x80,
  8, 6, 13, 1, 254, // 1e25 uni1E25
  158, 37, 8, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x87, 0x83, 0x0,
  10, 8, 13, 1, 0, // 1e26 uni1E26
  158, 38, 7, 0xd, 0xb8, 0x81, 0x83, 0xf2, 0x6, 0x0,
  8, 7, 13, 0, 0, // 1e27 uni1E27
  158, 39, 8, 0x36, 0x38, 0x40, 0x51, 0x70, 0x66, 0x10, 0xa1,
  10, 8, 14, 1, 253, // 1e28 uni1E28
  158, 40, 9, 0x20, 0x60, 0xfc, 0x81, 0x80, 0x8, 0x9, 0x1, 0x80,
  8, 6, 14, 1, 253, // 1e29 uni1E29
  158, 41, 10, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x84, 0x10, 0x12, 0x3, 0x0,
  10, 8, 14, 1, 253, // 1e2a uni1E2A
  158, 42, 8, 0x20, 0x60, 0xfc, 0x81, 0x83, 0x82, 0x20, 0x70,
  8, 6, 14, 1, 253, // 1e2b uni1E2B
  158, 43, 9, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x87, 0x84, 0x40, 0xe0,
  4, 5, 14, 0, 253, // 1e2c uni1E2C
  158, 44, 6, 0x8, 0x2c, 0xe, 0x1a, 0xb, 0x0,
  3, 5, 14, 255, 253, // 1e2d uni1E2D
  158, 45, 7, 0x8, 0x1e, 0x8, 0x23, 0xe1, 0xa0, 0xb0,
  4, 5, 16, 0, 0, // 1e2e uni1E2E
  158, 46, 7, 0x4, 0x33, 0x8d, 0x8e, 0x8, 0x2c, 0x0,
  3, 3, 14, 0, 0, // 1e2f uni1E2F
  158, 47, 7, 0x8, 0x33, 0x8a, 0x7, 0x84, 0x8, 0xc0,
  9, 8, 14, 1, 0, // 1e30 uni1E30
  158, 48, 16, 0x2, 0x33, 0x88, 0x22, 0x10, 0x88, 0x24, 0xa, 0xd, 0x24, 0x8, 0x82, 0x10, 0x82, 0x20, 0x40,
  7, 6, 14, 1, 0, // 1e31 uni1E31
  158, 49, 14, 0x8, 0x33, 0xae, 0x52, 0x20, 0x90, 0x28, 0xc, 0x2, 0x80, 0x90, 0x22, 0x8, 0x40,
  9, 8, 13, 1, 254, // 1e32 uni1E32
  158, 50, 15, 0x20, 0x88, 0x42, 0x20, 0x90, 0x28, 0x34, 0x90, 0x22, 0x8, 0x42, 0x8, 0x81, 0xe0, 0x60,
  7, 6, 13, 1, 254, // 1e33 uni1E33
  158, 51, 13, 0xb9, 0x48, 0x82, 0x40, 0xa0, 0x30, 0xa, 0x2, 0x40, 0x88, 0x21, 0x38, 0x30,
  9, 8, 13, 1, 254, // 1e34 uni1E34
  158, 52, 15, 0x20, 0x88, 0x42, 0x20, 0x90, 0x28, 0x34, 0x90, 0x22, 0x8, 0x42, 0x8, 0x81, 0xe0, 0xf0,
  7, 6, 13, 1, 254, // 1e35 uni1E35
  158, 53, 13, 0xb9, 0x48, 0x82, 0x40, 0xa0, 0x30, 0xa, 0x2, 0x40, 0x88, 0x21, 0x38, 0x78,
  8, 6, 13, 2, 254, // 1e36 uni1E36
  158, 54, 5, 0xba, 0x35, 0x3f, 0x38, 0x30,
  3, 2, 13, 1, 254, // 1e37 uni1E37
  158, 55, 4, 0xba, 0xc0, 0xe3, 0x0,
  8, 7, 15, 1, 254, // 1e38 uni1E38
  158, 56, 8, 0x3c, 0x38, 0x40, 0x8d, 0x47, 0xee, 0x6, 0x0,
  3, 4, 15, 0, 254, // 1e39 uni1E39
  158, 57, 6, 0x3c, 0x38, 0x40, 0xb0, 0x38, 0x60,
  8, 6, 13, 2, 254, // 1e3a uni1E3A
  158, 58, 5, 0xba, 0x35, 0x3f, 0x38, 0x78,
  3, 4, 13, 0, 254, // 1e3b uni1E3B
  158, 59, 5, 0x10, 0x2c, 0xe, 0x3c, 0x0,
  8, 6, 14, 2, 253, // 1e3c uni1E3C
  158, 60, 7, 0xba, 0x35, 0x3f, 0x38, 0x20, 0x14, 0x0,
  3, 3, 14, 0, 253, // 1e3d uni1E3D
  158, 61, 6, 0x10, 0x2c, 0xe, 0x10, 0xa, 0x0,
  12, 11, 14, 0, 0, // 1e3e uni1E3E
  158, 62, 17, 0x0, 0x9c, 0x79, 0xb8, 0x20, 0x9d, 0x52, 0x80, 0xa0, 0x52, 0x44, 0x20, 0x52, 0x29, 0x52, 0x11, 0x50,
  11, 9, 11, 1, 0, // 1e3f uni1E3F
  158, 63, 9, 0x1, 0x1c, 0x79, 0x2c, 0xd3, 0x32, 0xef, 0x6c, 0x10,
  12, 11, 13, 0, 0, // 1e40 uni1E40
  158, 64, 16, 0x1, 0x9e, 0x6e, 0x8, 0x27, 0x54, 0xa0, 0x28, 0x14, 0x91, 0x8, 0x14, 0x8a, 0x54, 0x84, 0x54,
  11, 9, 10, 1, 0, // 1e41 uni1E41
  158, 65, 8, 0x6, 0x1e, 0x4b, 0x34, 0xcc, 0xbb, 0xdb, 0x4,
  12, 11, 13, 0, 254, // 1e42 uni1E42
  158, 66, 16, 0xb8, 0x20, 0x9d, 0x52, 0x80, 0xa0, 0x52, 0x44, 0x20, 0x52, 0x29, 0x52, 0x11, 0x5e, 0xe0, 0x19,
  11, 9, 10, 1, 254, // 1e43 uni1E43
  158, 67, 8, 0x2c, 0xd3, 0x32, 0xef, 0x6c, 0x1e, 0xe0, 0x31,
  10, 8, 13, 1, 0, // 1e44 uni1E44
  158, 68, 11, 0x6, 0x38, 0xc1, 0x28, 0x52, 0x45, 0x22, 0x52, 0x15, 0x20, 0xd0,
  8, 6, 10, 1, 0, // 1e45 uni1E45
  158, 69, 7, 0xc, 0x38, 0xb8, 0x33, 0x8, 0x48, 0x40,
  10, 8, 13, 1, 254, // 1e46 uni1E46
  158, 70, 11, 0x30, 0x4a, 0x14, 0x91, 0x48, 0x94, 0x85, 0x48, 0x37, 0x81, 0x80,
  8, 6, 10, 1, 254, // 1e47 uni1E47
  158, 71, 7, 0x2e, 0xc, 0xc2, 0x12, 0x1e, 0xc, 0x0,
  10, 8, 13, 1, 254, // 1e48 uni1E48
  158, 72, 11, 0x30, 0x4a, 0x14, 0x91, 0x48, 0x94, 0x85, 0x48, 0x37, 0x83, 0xc0,
  8, 6, 10, 1, 254, // 1e49 uni1E49
  158, 73, 7, 0x2e, 0xc, 0xc2, 0x12, 0x1e, 0x1e, 0x0,
  10, 8, 14, 1, 253, // 1e4a uni1E4A
  158, 74, 12, 0x30, 0x4a, 0x14, 0x91, 0x48, 0x94, 0x85, 0x48, 0x37, 0x80, 0x80, 0x50,
  8, 6, 11, 1, 253, // 1e4b uni1E4B
  158, 75, 8, 0x2e, 0xc, 0xc2, 0x12, 0x1e, 0x4, 0x2, 0x80,
  11, 9, 17, 1, 0, // 1e4c uni1E4C
  158, 76, 19, 0x1, 0x1c, 0x79, 0x6, 0x90, 0xb1, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  8, 6, 14, 1, 0, // 1e4d uni1E4D
  158, 77, 13, 0x4, 0x33, 0x86, 0x82, 0xc3, 0x87, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x1e, 0x0,
  11, 9, 16, 1, 0, // 1e4e uni1E4E
  158, 78, 18, 0xd, 0x9e, 0x41, 0xa4, 0x2c, 0x79, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x8d, 0x10, 0x78, 0x63, 0x41, 0xc4,
  8, 6, 13, 1, 0, // 1e4f uni1E4F
  158, 79, 12, 0x36, 0x38, 0x68, 0x2c, 0x38, 0x78, 0x33, 0x8, 0x45, 0x4c, 0xc1, 0xe0,
  11, 9, 16, 1, 0, // 1e50 uni1E50
  158, 80, 17, 0x4, 0x1a, 0x79, 0x7, 0x9e, 0x41, 0xc4, 0x63, 0x44, 0x16, 0xeb, 0xa3, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  8, 6, 13, 1, 0, // 1e51 uni1E51
  158, 81, 11, 0x8, 0x2b, 0x87, 0x8e, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  11, 9, 16, 1, 0, // 1e52 uni1E52
  158, 82, 17, 0x1, 0x1c, 0x79, 0x7, 0x9e, 0x41, 0xc4, 0x63, 0x44, 0x16, 0xeb, 0xa3, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  8, 6, 13, 1, 0, // 1e53 uni1E53
  158, 83, 11, 0x4, 0x33, 0x87, 0x8e, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  9, 7, 14, 1, 0, // 1e54 uni1E54
  158, 84, 10, 0x2, 0x33, 0x8f, 0xc2, 0x18, 0x82, 0x74, 0xfc, 0xba, 0x0,
  8, 6, 14, 1, 253, // 1e55 uni1E55
  158, 85, 11, 0x4, 0x33, 0x8b, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x2e, 0x2e, 0x50,
  9, 7, 13, 1, 0, // 1e56 uni1E56
  158, 86, 9, 0xc, 0x38, 0xfc, 0x21, 0x88, 0x27, 0x4f, 0xcb, 0xa0,
  8, 6, 13, 1, 253, // 1e57 uni1E57
  158, 87, 10, 0xc, 0x38, 0xb8, 0x33, 0x8, 0x45, 0x4c, 0xc2, 0xe2, 0xe5,
  10, 8, 13, 1, 0, // 1e58 uni1E58
  158, 88, 12, 0x6, 0x38, 0xfe, 0x20, 0xc8, 0x14, 0x82, 0x3f, 0x8, 0x22, 0x5, 0x50,
  5, 4, 10, 1, 0, // 1e59 uni1E59
  158, 89, 6, 0x18, 0x38, 0xb0, 0x30, 0x32, 0x10,
  10, 8, 13, 1, 254, // 1e5a uni1E5A
  158, 90, 12, 0x3f, 0x88, 0x32, 0x5, 0x20, 0x8f, 0xc2, 0x8, 0x81, 0x57, 0x81, 0x80,
  5, 4, 10, 1, 254, // 1e5b uni1E5B
  158, 91, 6, 0x2c, 0xc, 0xc, 0x87, 0x8c, 0x0,
  10, 8, 15, 1, 254, // 1e5c uni1E5C
  158, 92, 14, 0xf, 0x38, 0xfe, 0x20, 0xc8, 0x14, 0x82, 0x3f, 0x8, 0x22, 0x5, 0x5e, 0x6, 0x0,
  5, 4, 12, 1, 254, // 1e5d uni1E5D
  158, 93, 8, 0x3c, 0x38, 0xb0, 0x30, 0x32, 0x1e, 0x30, 0x0,
  10, 8, 13, 1, 254, // 1e5e uni1E5E
  158, 94, 12, 0x3f, 0x88, 0x32, 0x5, 0x20, 0x8f, 0xc2, 0x8, 0x81, 0x57, 0x83, 0xc0,
  5, 5, 10, 0, 254, // 1e5f uni1E5F
  158, 95, 6, 0x16, 0x6, 0xf, 0x61, 0xe3, 0xc0,
  9, 7, 13, 1, 0, // 1e60 uni1E60
  158, 96, 15, 0x6, 0x38, 0x38, 0x31, 0x88, 0x2b, 0x86, 0x0, 0x60, 0x6, 0xf0, 0x82, 0x31, 0x83, 0x80,
  7, 5, 10, 1, 0, // 1e61 uni1E61
  158, 97, 12, 0x18, 0x38, 0x70, 0x22, 0xc, 0x1, 0xc0, 0x18, 0xf0, 0x88, 0x1c, 0x0,
  9, 7, 13, 1, 254, // 1e62 uni1E62
  158, 98, 15, 0xe, 0xc, 0x62, 0xa, 0xe1, 0x80, 0x18, 0x1, 0xbc, 0x20, 0x8c, 0x60, 0xe3, 0x81, 0x80,
  7, 5, 10, 1, 254, // 1e63 uni1E63
  158, 99, 12, 0x1c, 0x8, 0x83, 0x0, 0x70, 0x6, 0x3c, 0x22, 0x7, 0xe, 0xc, 0x0,
  9, 7, 16, 1, 0, // 1e64 uni1E64
  158, 100, 17, 0x6, 0x38, 0x8, 0xce, 0xe, 0xc, 0x62, 0xa, 0xe1, 0x80, 0x18, 0x1, 0xbc, 0x20, 0x8c, 0x60, 0xe0,
  7, 5, 13, 1, 0, // 1e65 uni1E65
  158, 101, 14, 0xc, 0x38, 0x10, 0xce, 0x1c, 0x8, 0x83, 0x0, 0x70, 0x6, 0x3c, 0x22, 0x7, 0x0,
  9, 7, 13, 1, 0, // 1e66 uni1E66
  158, 102, 13, 0x6, 0x38, 0x28, 0xfb, 0x87, 0xc2, 0xa, 0xe1, 0xf0, 0x2, 0x48, 0x21, 0xf0,
  8, 6, 13, 1, 0, // 1e67 uni1E67
  158, 103, 14, 0xc, 0x38, 0x50, 0xfb, 0x87, 0x82, 0x12, 0xe1, 0xe0, 0xc, 0xf0, 0x84, 0x1e, 0x0,
  9, 7, 15, 1, 254, // 1e68 uni1E68
  158, 104, 17, 0xc, 0x38, 0x38, 0x31, 0x88, 0x2b, 0x86, 0x0, 0x60, 0x6, 0xf0, 0x82, 0x31, 0x83, 0x8e, 0x6, 0x0,
  7, 5, 12, 1, 254, // 1e69 uni1E69
  158, 105, 13, 0x18, 0x38, 0x70, 0x22, 0xc, 0x1, 0xc0, 0x18, 0xf0, 0x88, 0x1c, 0x38, 0x30,
  9, 9, 13, 0, 0, // 1e6a uni1E6A
  158, 106, 7, 0x3, 0x1e, 0x7f, 0xb8, 0x8, 0xeb, 0x20,
  4, 4, 12, 0, 0, // 1e6b uni1E6B
  158, 107, 7, 0x18, 0x38, 0x40, 0x6f, 0xfa, 0x10, 0xc0,
  9, 9, 13, 0, 254, // 1e6c uni1E6C
  158, 108, 7, 0xfe, 0xe0, 0x23, 0xac, 0x8e, 0x40, 0xc4,
  4, 4, 12, 0, 254, // 1e6d uni1E6D
  158, 109, 7, 0x10, 0x1b, 0xfe, 0x84, 0x30, 0xe1, 0x80,
  9, 9, 13, 0, 254, // 1e6e uni1E6E
  158, 110, 7, 0xfe, 0xe0, 0x23, 0xac, 0x8e, 0x41, 0xe4,
  4, 4, 12, 0, 254, // 1e6f uni1E6F
  158, 111, 7, 0x10, 0x1b, 0xfe, 0x84, 0x30, 0xe3, 0xc0,
  9, 9, 14, 0, 253, // 1e70 uni1E70
  158, 112, 9, 0xfe, 0xe0, 0x23, 0xac, 0x8e, 0x40, 0x84, 0x14, 0x40,
  4, 4, 13, 0, 253, // 1e71 uni1E71
  158, 113, 8, 0x10, 0x1b, 0xfe, 0x84, 0x30, 0xe0, 0x80, 0x50,
  10, 8, 13, 1, 254, // 1e72 uni1E72
  158, 114, 7, 0x20, 0x63, 0x44, 0x20, 0xf3, 0x83, 0x60,
  7, 6, 10, 1, 254, // 1e73 uni1E73
  158, 115, 7, 0x21, 0x21, 0x33, 0x7, 0x4e, 0x1b, 0x0,
  10, 8, 14, 1, 253, // 1e74 uni1E74
  158, 116, 8, 0x20, 0x63, 0x44, 0x20, 0xf3, 0x83, 0x41, 0x60,
  7, 6, 11, 1, 253, // 1e75 uni1E75
  158, 117, 8, 0x21, 0x21, 0x33, 0x7, 0x4e, 0x1a, 0xb, 0x0,
  10, 8, 14, 1, 253, // 1e76 uni1E76
  158, 118, 8, 0x20, 0x63, 0x44, 0x20, 0xf3, 0x80, 0x80, 0x50,
  7, 6, 11, 1, 253, // 1e77 uni1E77
  158, 119, 8, 0x21, 0x21, 0x33, 0x7, 0x4e, 0x4, 0x2, 0x80,
  10, 8, 17, 1, 0, // 1e78 uni1E78
  158, 120, 10, 0x1, 0x33, 0x81, 0xa0, 0xb3, 0x88, 0x18, 0xd1, 0x8, 0x3c,
  7, 6, 14, 1, 0, // 1e79 uni1E79
  158, 121, 10, 0x2, 0x33, 0x83, 0x41, 0x63, 0x88, 0x48, 0x4c, 0xc1, 0xd0,
  10, 8, 15, 1, 0, // 1e7a uni1E7A
  158, 122, 9, 0xd, 0xb8, 0x3c, 0xe2, 0x6, 0x34, 0x42, 0xf, 0x0,
  7, 6, 12, 1, 0, // 1e7b uni1E7B
  158, 123, 8, 0x1b, 0x38, 0x78, 0xe2, 0x12, 0x13, 0x30, 0x74,
  9, 9, 14, 0, 0, // 1e7c uni1E7C
  158, 124, 15, 0x6, 0x90, 0xb1, 0xe6, 0xeb, 0x94, 0x41, 0xe5, 0x18, 0xd0, 0x89, 0x50, 0x51, 0x5f, 0x95,
  7, 7, 11, 0, 0, // 1e7d uni1E7D
  158, 125, 9, 0xd, 0x5, 0x8e, 0x20, 0x91, 0x11, 0x42, 0x87, 0xe0,
  9, 9, 13, 0, 254, // 1e7e uni1E7E
  158, 126, 14, 0xba, 0xe5, 0x10, 0x79, 0x46, 0x34, 0x22, 0x54, 0x14, 0x57, 0xe5, 0x79, 0x3, 0x10,
  7, 7, 10, 0, 254, // 1e7f uni1E7F
  158, 127, 8, 0x20, 0x91, 0x11, 0x42, 0x87, 0xee, 0x6, 0x0,
  13, 13, 14, 0, 0, // 1e80 Wgrave
  158, 128, 15, 0x1, 0x1a, 0x79, 0x20, 0x80, 0x85, 0x21, 0x51, 0x17, 0x20, 0xa, 0xa, 0x8, 0x3e, 0xc5,
  10, 9, 11, 0, 0, // 1e81 wgrave
  158, 129, 12, 0x4, 0x1a, 0x79, 0x22, 0x2e, 0x80, 0x49, 0xe5, 0x15, 0x50, 0x89, 0x50,
  13, 13, 14, 0, 0, // 1e82 Wacute
  158, 130, 15, 0xb5, 0xc7, 0x92, 0x8, 0x8, 0x52, 0x15, 0x11, 0x72, 0x0, 0xa0, 0xa0, 0x83, 0xec, 0x50,
  10, 9, 11, 0, 0, // 1e83 wacute
  158, 131, 12, 0x1, 0x1c, 0x79, 0x22, 0x2e, 0x80, 0x49, 0xe5, 0x15, 0x50, 0x89, 0x50,
  13, 13, 13, 0, 0, // 1e84 Wdieresis
  158, 132, 15, 0x3, 0x6e, 0xee, 0x20, 0x80, 0x85, 0x21, 0x51, 0x17, 0x20, 0xa, 0xa, 0x8, 0x3e, 0xc5,
  10, 9, 10, 0, 0, // 1e85 wdieresis
  158, 133, 11, 0xd, 0x9e, 0x48, 0x8b, 0xa0, 0x12, 0x79, 0x45, 0x54, 0x22, 0x54,
  13, 13, 13, 0, 0, // 1e86 uni1E86
  158, 134, 15, 0x0, 0xde, 0x48, 0x20, 0x21, 0x48, 0x54, 0x45, 0xc8, 0x2, 0x82, 0x82, 0xf, 0xb1, 0x40,
  10, 9, 10, 0, 0, // 1e87 uni1E87
  158, 135, 11, 0x3, 0x1e, 0x48, 0x8b, 0xa0, 0x12, 0x79, 0x45, 0x54, 0x22, 0x54,
  13, 13, 13, 0, 254, // 1e88 uni1E88
  158, 136, 15, 0x20, 0x80, 0x85, 0x21, 0x51, 0x17, 0x20, 0xa, 0xa, 0x8, 0x3e, 0xc5, 0xee, 0x0, 0xd0,
  10, 9, 10, 0, 254, // 1e89 uni1E89
  158, 137, 11, 0x22, 0x2e, 0x80, 0x49, 0xe5, 0x15, 0x50, 0x89, 0x5e, 0x40, 0xc4,
  9, 9, 13, 0, 0, // 1e8a uni1E8A
  158, 138, 17, 0x3, 0x1e, 0x6e, 0xb8, 0x41, 0xe0, 0x89, 0x5, 0x1f, 0x95, 0x5, 0x10, 0x89, 0x10, 0x55, 0xba, 0xe0,
  7, 7, 10, 0, 0, // 1e8b uni1E8B
  158, 139, 11, 0x6, 0x38, 0xc6, 0x11, 0x2, 0x8f, 0x90, 0xa0, 0x44, 0x31, 0x80,
  9, 9, 13, 0, 0, // 1e8c uni1E8C
  158, 140, 17, 0xd, 0x9e, 0x6e, 0xb8, 0x41, 0xe0, 0x89, 0x5, 0x1f, 0x95, 0x5, 0x10, 0x89, 0x10, 0x55, 0xba, 0xe0,
  7, 7, 10, 0, 0, // 1e8d uni1E8D
  158, 141, 11, 0x1b, 0x38, 0xc6, 0x11, 0x2, 0x8f, 0x90, 0xa0, 0x44, 0x31, 0x80,
  9, 9, 13, 0, 0, // 1e8e uni1E8E
  158, 142, 14, 0x3, 0x1e, 0x6e, 0xb8, 0xc1, 0x44, 0x1e, 0x8, 0x95, 0x5, 0x10, 0x71, 0xfa, 0x30,
  7, 7, 13, 0, 253, // 1e8f uni1E8F
  158, 143, 12, 0xc, 0x38, 0x82, 0x30, 0x84, 0x44, 0x24, 0xa, 0x1, 0x8f, 0x5d, 0xc0,
  9, 7, 14, 1, 0, // 1e90 uni1E90
  158, 144, 12, 0x4, 0x2, 0x8e, 0x3f, 0x80, 0x2c, 0xcd, 0xf7, 0x37, 0xdc, 0x3f, 0x80,
  7, 6, 11, 0, 0, // 1e91 uni1E91
  158, 145, 10, 0x4, 0x2, 0x8e, 0x3f, 0x0, 0x4c, 0xcc, 0xcc, 0x3f, 0x0,
  9, 7, 13, 1, 254, // 1e92 uni1E92
  158, 146, 10, 0x3f, 0x80, 0x2c, 0xcd, 0xf7, 0x37, 0xdc, 0x3f, 0xb8, 0x30,
  7, 6, 10, 0, 254, // 1e93 uni1E93
  158, 147, 8, 0x3f, 0x0, 0x4c, 0xcc, 0xcc, 0x3f, 0x38, 0x30,
  9, 7, 13, 1, 254, // 1e94 uni1E94
  158, 148, 10, 0x3f, 0x80, 0x2c, 0xcd, 0xf7, 0x37, 0xdc, 0x3f, 0xb8, 0x78,
  7, 6, 10, 0, 254, // 1e95 uni1E95
  158, 149, 8, 0x3f, 0x0, 0x4c, 0xcc, 0xcc, 0x3f, 0x38, 0x78,
  8, 6, 13, 1, 254, // 1e96 uni1E96
  158, 150, 8, 0xb9, 0x4b, 0x83, 0x30, 0x84, 0x87, 0x87, 0x80,
  4, 5, 12, 255, 0, // 1e97 uni1E97
  158, 151, 7, 0x36, 0x38, 0x20, 0x6f, 0xfa, 0x10, 0x60,
  10, 9, 12, 0, 0, // 1e98 uni1E98
  158, 152, 14, 0x3, 0x10, 0x49, 0x3, 0x1e, 0x48, 0x8b, 0xa0, 0x12, 0x79, 0x45, 0x54, 0x22, 0x54,
  7, 7, 15, 0, 253, // 1e99 uni1E99
  158, 153, 14, 0xc, 0x4, 0x80, 0xc3, 0x88, 0x23, 0x8, 0x44, 0x42, 0x40, 0xa0, 0x18, 0xf5, 0xdc,
  9, 9, 13, 0, 254, // 1ea0 uni1EA0
  158, 160, 16, 0x2, 0x1b, 0xd0, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5, 0xee, 0x3, 0x10,
  8, 7, 10, 1, 254, // 1ea1 uni1EA1
  158, 161, 12, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76, 0xe0, 0xc0,
  9, 9, 17, 0, 0, // 1ea4 uni1EA4
  158, 164, 20, 0x1, 0x1c, 0x79, 0x3, 0x10, 0x49, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  8, 7, 14, 1, 0, // 1ea5 uni1EA5
  158, 165, 16, 0x2, 0x33, 0x83, 0x1, 0x23, 0x87, 0x83, 0x30, 0x4, 0x1f, 0xc, 0x42, 0x10, 0xcc, 0x1d, 0x80,
  9, 9, 17, 0, 0, // 1ea6 uni1EA6
  158, 166, 20, 0x4, 0x1a, 0x79, 0x3, 0x10, 0x49, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  8, 7, 14, 1, 0, // 1ea7 uni1EA7
  158, 167, 16, 0x8, 0x2b, 0x83, 0x1, 0x23, 0x87, 0x83, 0x30, 0x4, 0x1f, 0xc, 0x42, 0x10, 0xcc, 0x1d, 0x80,
  9, 9, 17, 0, 0, // 1eaa uni1EAA
  158, 170, 21, 0x6, 0x90, 0xb1, 0xe4, 0xc, 0x41, 0x27, 0x90, 0x21, 0xbd, 0x5, 0x15, 0x8, 0x95, 0x10, 0x51, 0xfd, 0x10, 0x5b, 0xae, 0x50,
  8, 7, 14, 1, 0, // 1eab uni1EAB
  158, 171, 16, 0xd, 0x5, 0x8e, 0xc, 0x4, 0x8e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76,
  9, 9, 16, 0, 254, // 1eac uni1EAC
  158, 172, 20, 0x2, 0x10, 0x51, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x97, 0xb8, 0xc, 0x40,
  8, 7, 13, 1, 254, // 1ead uni1EAD
  158, 173, 15, 0x4, 0x2, 0x8e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76, 0xe0, 0xc0,
  9, 9, 17, 0, 0, // 1eae uni1EAE
  158, 174, 20, 0x1, 0x1c, 0x79, 0x8, 0x90, 0x71, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  8, 7, 14, 1, 0, // 1eaf uni1EAF
  158, 175, 16, 0x2, 0x33, 0x84, 0x40, 0xe3, 0x87, 0x83, 0x30, 0x4, 0x1f, 0xc, 0x42, 0x10, 0xcc, 0x1d, 0x80,
  9, 9, 17, 0, 0, // 1eb0 uni1EB0
  158, 176, 20, 0x4, 0x1a, 0x79, 0x8, 0x90, 0x71, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x94,
  8, 7, 14, 1, 0, // 1eb1 uni1EB1
  158, 177, 16, 0x8, 0x2b, 0x84, 0x40, 0xe3, 0x87, 0x83, 0x30, 0x4, 0x1f, 0xc, 0x42, 0x10, 0xcc, 0x1d, 0x80,
  9, 9, 17, 0, 0, // 1eb4 uni1EB4
  158, 180, 21, 0x6, 0x90, 0xb1, 0xe4, 0x22, 0x41, 0xc7, 0x90, 0x21, 0xbd, 0x5, 0x15, 0x8, 0x95, 0x10, 0x51, 0xfd, 0x10, 0x5b, 0xae, 0x50,
  8, 7, 14, 1, 0, // 1eb5 uni1EB5
  158, 181, 16, 0xd, 0x5, 0x8e, 0x11, 0x3, 0x8e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76,
  9, 9, 16, 0, 254, // 1eb6 uni1EB6
  158, 182, 20, 0x8, 0x90, 0x71, 0xe4, 0x8, 0x6f, 0x41, 0x45, 0x42, 0x25, 0x44, 0x14, 0x7f, 0x44, 0x16, 0xeb, 0x97, 0xb8, 0xc, 0x40,
  8, 7, 13, 1, 254, // 1eb7 uni1EB7
  158, 183, 15, 0x11, 0x3, 0x8e, 0x1e, 0xc, 0xc0, 0x10, 0x7c, 0x31, 0x8, 0x43, 0x30, 0x76, 0xe0, 0xc0,
  9, 7, 13, 1, 254, // 1eb8 uni1EB8
  158, 184, 9, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xfb, 0x83, 0x0,
  8, 6, 10, 1, 254, // 1eb9 uni1EB9
  158, 185, 11, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x8e, 0xc, 0x0,
  9, 7, 14, 1, 0, // 1ebc uni1EBC
  158, 188, 10, 0xd, 0x5, 0x8e, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8,
  8, 6, 11, 1, 0, // 1ebd uni1EBD
  158, 189, 12, 0xd, 0x5, 0x8e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  9, 7, 17, 1, 0, // 1ebe uni1EBE
  158, 190, 12, 0x2, 0x33, 0x81, 0x80, 0x93, 0x8f, 0xeb, 0x95, 0x3f, 0x2e, 0x54, 0xfe,
  8, 6, 14, 1, 0, // 1ebf uni1EBF
  158, 191, 14, 0x4, 0x33, 0x83, 0x1, 0x23, 0x87, 0x83, 0x30, 0x84, 0x3f, 0x2e, 0x4c, 0xc1, 0xe0,
  9, 7, 17, 1, 0, // 1ec0 uni1EC0
  158, 192, 12, 0x8, 0x2b, 0x81, 0x80, 0x93, 0x8f, 0xeb, 0x95, 0x3f, 0x2e, 0x54, 0xfe,
  8, 6, 14, 1, 0, // 1ec1 uni1EC1
  158, 193, 14, 0x8, 0x2b, 0x83, 0x1, 0x23, 0x87, 0x83, 0x30, 0x84, 0x3f, 0x2e, 0x4c, 0xc1, 0xe0,
  9, 7, 17, 1, 0, // 1ec4 uni1EC4
  158, 196, 13, 0xd, 0x5, 0x8e, 0x6, 0x2, 0x4e, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xf8,
  8, 6, 14, 1, 0, // 1ec5 uni1EC5
  158, 197, 15, 0xd, 0x5, 0x8e, 0xc, 0x4, 0x8e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x80,
  9, 7, 16, 1, 254, // 1ec6 uni1EC6
  158, 198, 12, 0x8, 0x5, 0xe, 0x3f, 0xae, 0x54, 0xfc, 0xb9, 0x53, 0xfb, 0x83, 0x0,
  8, 6, 13, 1, 254, // 1ec7 uni1EC7
  158, 199, 14, 0x4, 0x2, 0x8e, 0x1e, 0xc, 0xc2, 0x10, 0xfc, 0xb9, 0x33, 0x7, 0x8e, 0xc, 0x0,
  4, 2, 13, 2, 254, // 1eca uni1ECA
  158, 202, 4, 0xba, 0xc0, 0xe3, 0x0,
  3, 2, 13, 1, 254, // 1ecb uni1ECB
  158, 203, 5, 0xb9, 0xeb, 0xa3, 0xe3, 0x0,
  11, 9, 13, 1, 254, // 1ecc uni1ECC
  158, 204, 14, 0x7, 0x11, 0x8d, 0x10, 0x5b, 0xae, 0x8d, 0x10, 0x78, 0x63, 0x41, 0xc7, 0x90, 0x31,
  8, 6, 10, 1, 254, // 1ecd uni1ECD
  158, 205, 9, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78, 0xe0, 0xc0,
  11, 9, 17, 1, 0, // 1ed0 uni1ED0
  158, 208, 19, 0x1, 0x1c, 0x79, 0x3, 0x10, 0x49, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  8, 6, 14, 1, 0, // 1ed1 uni1ED1
  158, 209, 13, 0x4, 0x33, 0x83, 0x1, 0x23, 0x87, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x1e, 0x0,
  11, 9, 17, 1, 0, // 1ed2 uni1ED2
  158, 210, 19, 0x4, 0x1a, 0x79, 0x3, 0x10, 0x49, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x10,
  8, 6, 14, 1, 0, // 1ed3 uni1ED3
  158, 211, 13, 0x8, 0x2b, 0x83, 0x1, 0x23, 0x87, 0x83, 0x30, 0x84, 0x54, 0xcc, 0x1e, 0x0,
  11, 9, 17, 1, 0, // 1ed6 uni1ED6
  158, 214, 20, 0x6, 0x90, 0xb1, 0xe4, 0xc, 0x41, 0x27, 0x90, 0x71, 0x18, 0xd1, 0x5, 0xba, 0xe8, 0xd1, 0x7, 0x86, 0x34, 0x1c, 0x40,
  8, 6, 14, 1, 0, // 1ed7 uni1ED7
  158, 215, 13, 0xd, 0x5, 0x8e, 0xc, 0x4, 0x8e, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78,
  11, 9, 16, 1, 254, // 1ed8 uni1ED8
  158, 216, 18, 0x2, 0x10, 0x51, 0xe4, 0x1c, 0x46, 0x34, 0x41, 0x6e, 0xba, 0x34, 0x41, 0xe1, 0x8d, 0x7, 0x1e, 0x40, 0xc4,
  8, 6, 13, 1, 254, // 1ed9 uni1ED9
  158, 217, 12, 0x4, 0x2, 0x8e, 0x1e, 0xc, 0xc2, 0x11, 0x53, 0x30, 0x78, 0xe0, 0xc0,
  11, 10, 14, 1, 0, // 1eda uni1EDA
  158, 218, 16, 0x0, 0x9c, 0x79, 0x7, 0xc, 0x1, 0x8f, 0xc1, 0x7, 0x2e, 0x8d, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  8, 8, 11, 1, 0, // 1edb uni1EDB
  158, 219, 11, 0x2, 0x33, 0x87, 0xb3, 0x34, 0x86, 0x21, 0x14, 0xcc, 0x1e, 0x0,
  11, 10, 14, 1, 0, // 1edc uni1EDC
  158, 220, 16, 0x2, 0x1a, 0x79, 0x7, 0xc, 0x1, 0x8f, 0xc1, 0x7, 0x2e, 0x8d, 0x44, 0x1e, 0x18, 0xd0, 0x71,
  8, 8, 11, 1, 0, // 1edd uni1EDD
  158, 221, 11, 0x4, 0x2b, 0x87, 0xb3, 0x34, 0x86, 0x21, 0x14, 0xcc, 0x1e, 0x0,
  11, 10, 14, 1, 0, // 1ee0 uni1EE0
  158, 224, 17, 0x3, 0x50, 0x59, 0xe4, 0x1c, 0x30, 0x6, 0x3f, 0x4, 0x1c, 0xba, 0x35, 0x10, 0x78, 0x63, 0x41, 0xc4,
  8, 8, 11, 1, 0, // 1ee1 uni1EE1
  158, 225, 11, 0x6, 0x82, 0xce, 0x1e, 0xcc, 0xd2, 0x18, 0x84, 0x53, 0x30, 0x78,
  11, 10, 13, 1, 254, // 1ee2 uni1EE2
  158, 226, 16, 0x7, 0xc, 0x1, 0x8f, 0xc1, 0x7, 0x2e, 0x8d, 0x44, 0x1e, 0x18, 0xd0, 0x71, 0xe4, 0xc, 0x40,
  8, 8, 10, 1, 254, // 1ee3 uni1EE3
  158, 227, 10, 0x1e, 0xcc, 0xd2, 0x18, 0x84, 0x53, 0x30, 0x78, 0xe0, 0xc0,
  10, 8, 13, 1, 254, // 1ee4 uni1EE4
  158, 228, 7, 0x20, 0x63, 0x44, 0x20, 0xf3, 0x81, 0x80,
  7, 6, 10, 1, 254, // 1ee5 uni1EE5
  158, 229, 7, 0x21, 0x21, 0x33, 0x7, 0x4e, 0xc, 0x0,
  10, 10, 14, 1, 0, // 1ee8 uni1EE8
  158, 232, 13, 0x0, 0x9c, 0x79, 0x20, 0x4c, 0x7, 0xc7, 0x1e, 0xb0, 0x4, 0x24, 0x3c, 0x40,
  7, 8, 11, 1, 0, // 1ee9 uni1EE9
  158, 233, 11, 0x1, 0x33, 0x88, 0x72, 0x14, 0x86, 0x21, 0x14, 0xcc, 0x1d, 0x0,
  10, 10, 14, 1, 0, // 1eea uni1EEA
  158, 234, 13, 0x2, 0x1a, 0x79, 0x20, 0x4c, 0x7, 0xc7, 0x1e, 0xb0, 0x4, 0x24, 0x3c, 0x40,
  7, 8, 11, 1, 0, // 1eeb uni1EEB
  158, 235, 11, 0x4, 0x2b, 0x88, 0x72, 0x14, 0x86, 0x21, 0x14, 0xcc, 0x1d, 0x0,
  10, 10, 14, 1, 0, // 1eee uni1EEE
  158, 238, 13, 0x3, 0x50, 0x59, 0xe4, 0x81, 0x30, 0x1f, 0x1c, 0x7a, 0xc0, 0x10, 0x90, 0xf1,
  7, 8, 11, 1, 0, // 1eef uni1EEF
  158, 239, 11, 0x6, 0x82, 0xce, 0x21, 0xc8, 0x52, 0x18, 0x84, 0x53, 0x30, 0x74,
  10, 10, 13, 1, 254, // 1ef0 uni1EF0
  158, 240, 12, 0x20, 0x4c, 0x7, 0xc7, 0x1e, 0xb0, 0x4, 0x24, 0x3c, 0x79, 0x6, 0x10,
  7, 8, 10, 1, 254, // 1ef1 uni1EF1
  158, 241, 10, 0x21, 0xc8, 0x52, 0x18, 0x84, 0x53, 0x30, 0x74, 0xe0, 0xc0,
  9, 9, 14, 0, 0, // 1ef2 Ygrave
  158, 242, 15, 0x4, 0x1a, 0x79, 0xba, 0xe3, 0x5, 0x10, 0x78, 0x22, 0x54, 0x14, 0x41, 0xc7, 0xe8, 0xc0,
  7, 7, 14, 0, 253, // 1ef3 ygrave
  158, 243, 12, 0x8, 0x2b, 0x88, 0x23, 0x8, 0x44, 0x42, 0x40, 0xa0, 0x18, 0xf5, 0xdc,
  9, 9, 13, 0, 254, // 1ef4 uni1EF4
  158, 244, 14, 0xba, 0xe3, 0x5, 0x10, 0x78, 0x22, 0x54, 0x14, 0x41, 0xc7, 0xe8, 0xf9, 0x3, 0x10,
  7, 7, 13, 0, 251, // 1ef5 uni1EF5
  158, 245, 12, 0x20, 0x8c, 0x21, 0x11, 0x9, 0x2, 0x80, 0x63, 0xd7, 0x73, 0x83, 0x0,
  9, 9, 14, 0, 0, // 1ef8 uni1EF8
  158, 248, 15, 0x6, 0x90, 0xb1, 0xe6, 0xeb, 0x8c, 0x14, 0x41, 0xe0, 0x89, 0x50, 0x51, 0x7, 0x1f, 0xa3,
  7, 7, 14, 0, 253, // 1ef9 uni1EF9
  158, 249, 13, 0xd, 0x5, 0x8e, 0x20, 0x8c, 0x21, 0x11, 0x9, 0x2, 0x80, 0x63, 0xd7, 0x70,
  0xff]

/**
The characters from the General Punctuation Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/General_Punctuation )
This block has 111 assigned code points, but only 34 of
  them are present in this font.
  This block contains characters in the range 0x2000-0x206f.
  The bitmaps for this block in this font take up about 570 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
GENERAL_PUNCTUATION ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0x3a, 0x2, 0x0, 0x0, // Length 570.
  0xae, 0x75, 0xec, 0x16, 0x3d, 0xe7, 0xe7, 0x9a, 0x97, 0x1c, 0x85, 0xb, 0x30, 0xff, 0x11, 0x51, 0xb4, 0x60, 0x3d, 0x1e, 0x41, 0x5e, 0xce, 0xcd, 0x3f, 0x11, 0x64, 0x7d, 0xe1, 0x80, 0xbf, 0x6c, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x0, 0x20, 0x0, // Unicode range start 0x002000.
  116, 0x6f, 0x20, 0x0, // Unicode range end 0x00206f.
  0,
  7, 1, 0, 0, 0, // 2000 uni2000
  160, 0, 0,
  14, 1, 0, 0, 0, // 2001 uni2001
  160, 1, 0,
  7, 1, 0, 0, 0, // 2002 uni2002
  160, 2, 0,
  14, 1, 0, 0, 0, // 2003 uni2003
  160, 3, 0,
  5, 1, 0, 0, 0, // 2004 uni2004
  160, 4, 0,
  3, 1, 0, 0, 0, // 2005 uni2005
  160, 5, 0,
  2, 1, 0, 0, 0, // 2006 uni2006
  160, 6, 0,
  8, 1, 0, 0, 0, // 2007 uni2007
  160, 7, 0,
  3, 1, 0, 0, 0, // 2008 uni2008
  160, 8, 0,
  3, 1, 0, 0, 0, // 2009 uni2009
  160, 9, 0,
  1, 1, 0, 0, 0, // 200a uni200A
  160, 10, 0,
  0, 1, 0, 0, 0, // 200b uni200B
  160, 11, 0,
  4, 3, 1, 0, 4, // 2010 uni2010
  160, 16, 2, 0x38, 0x0,
  4, 3, 1, 0, 4, // 2011 uni2011
  160, 17, 2, 0x38, 0x0,
  8, 8, 1, 0, 4, // 2012 figuredash
  160, 18, 1, 0xfc,
  8, 8, 1, 0, 4, // 2013 endash
  160, 19, 1, 0xfc,
  14, 14, 1, 0, 4, // 2014 emdash
  160, 20, 2, 0xfc, 0xfc,
  14, 14, 1, 0, 4, // 2015 afii00208
  160, 21, 2, 0xfc, 0xfc,
  3, 2, 3, 0, 8, // 2018 quoteleft
  160, 24, 3, 0x10, 0x32, 0x40,
  3, 2, 3, 1, 8, // 2019 quoteright
  160, 25, 3, 0x30, 0x3c, 0xc0,
  3, 2, 3, 1, 254, // 201a quotesinglbase
  160, 26, 3, 0x30, 0x3c, 0xc0,
  3, 2, 3, 1, 8, // 201b quotereversed
  160, 27, 3, 0x30, 0x32, 0x80,
  6, 5, 3, 0, 8, // 201c quotedblleft
  160, 28, 3, 0x12, 0x32, 0x40,
  6, 5, 3, 1, 8, // 201d quotedblright
  160, 29, 3, 0x36, 0x3c, 0xc0,
  5, 5, 3, 0, 254, // 201e quotedblbase
  160, 30, 3, 0x36, 0x3c, 0xc0,
  6, 5, 3, 1, 8, // 201f uni201F
  160, 31, 3, 0x36, 0x3d, 0xa0,
  8, 7, 14, 0, 253, // 2020 dagger
  160, 32, 6, 0x4, 0x15, 0x3f, 0x81, 0x8, 0xd0,
  8, 7, 14, 0, 253, // 2021 daggerdbl
  160, 33, 9, 0x4, 0x15, 0x3f, 0x81, 0x5, 0x4f, 0xe0, 0x41, 0x50,
  5, 3, 4, 1, 3, // 2022 bullet
  160, 34, 3, 0x10, 0x2f, 0x7e,
  15, 12, 1, 1, 0, // 2026 ellipsis
  160, 38, 3, 0x31, 0x83, 0x0,
  13, 11, 11, 1, 0, // 2030 perthousand
  160, 48, 18, 0xb5, 0x18, 0x92, 0x49, 0x25, 0x11, 0x91, 0x2, 0x1c, 0x41, 0x63, 0x0, 0x29, 0x8, 0x14, 0x46, 0x30, 0x0,
  5, 3, 5, 1, 2, // 2039 guilsinglleft
  160, 57, 4, 0x8, 0x33, 0x2a, 0x80,
  5, 3, 5, 1, 2, // 203a guilsinglright
  160, 58, 3, 0xba, 0xab, 0x30,
  3, 5, 10, 255, 0, // 2044 fraction
  160, 68, 5, 0x2, 0x1c, 0x71, 0xc7, 0x10,
  0xff]

/**
The characters from the Superscripts and Subscripts Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Superscripts_and_Subscripts_%28Unicode_block%29 )
This block has 42 assigned code points, but only 3 of
  them are present in this font:
  oneinferior,
  twoinferior, and
  threeinferior.
  This block contains characters in the range 0x2070-0x209f.
  The bitmaps for this block in this font take up about 253 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
SUPERSCRIPTS_AND_SUBSCRIPTS ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0xfd, 0x0, 0x0, 0x0, // Length 253.
  0x6b, 0x94, 0x9b, 0xba, 0xb1, 0xa4, 0x87, 0xdd, 0x78, 0xb1, 0xb4, 0x76, 0x7a, 0x5b, 0x5d, 0x25, 0x80, 0xf3, 0xaf, 0x7e, 0x17, 0xda, 0xea, 0xd8, 0xf0, 0x83, 0x1c, 0xfd, 0xb7, 0xc4, 0x1d, 0xac, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x70, 0x20, 0x0, // Unicode range start 0x002070.
  116, 0x9f, 0x20, 0x0, // Unicode range end 0x00209f.
  0,
  5, 2, 6, 1, 253, // 2081 oneinferior
  160, 129, 4, 0x10, 0x37, 0xc5, 0x40,
  5, 4, 6, 0, 253, // 2082 twoinferior
  160, 130, 6, 0x18, 0x9, 0x0, 0x43, 0x30, 0xf0,
  5, 4, 6, 0, 253, // 2083 threeinferior
  160, 131, 6, 0x18, 0x9, 0xc, 0xa2, 0x40, 0x60,
  0xff]

/**
The characters from the Currency Symbols Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Currency_Symbols_%28Unicode_block%29 )
This block has 32 assigned code points, but only 5 of
  them are present in this font:
  Mill,
  Naira,
  Won,
  Euro, and
  Kip.
  This block contains characters in the range 0x20a0-0x20cf.
  The bitmaps for this block in this font take up about 324 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
CURRENCY_SYMBOLS ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0x44, 0x1, 0x0, 0x0, // Length 324.
  0x61, 0xa6, 0x7d, 0x4a, 0x65, 0xa7, 0x3f, 0xd5, 0x7e, 0x8e, 0xe, 0x90, 0x35, 0xa6, 0x2e, 0xa, 0x88, 0xcb, 0x14, 0xba, 0xca, 0x90, 0xb9, 0x1f, 0xe1, 0xc2, 0xd0, 0xa9, 0xfb, 0x38, 0xd3, 0x31, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0xa0, 0x20, 0x0, // Unicode range start 0x0020a0.
  116, 0xcf, 0x20, 0x0, // Unicode range end 0x0020cf.
  0,
  11, 9, 11, 1, 255, // 20a5 uni20A5
  160, 165, 12, 0x0, 0x95, 0x2d, 0xd3, 0x32, 0xe2, 0x31, 0x22, 0x21, 0xd5, 0x7d, 0xe0,
  10, 8, 11, 1, 0, // 20a6 uni20A6
  160, 166, 10, 0x30, 0x4a, 0x14, 0x91, 0xfc, 0x89, 0xfc, 0x85, 0x48, 0x34,
  13, 13, 11, 0, 0, // 20a9 uni20A9
  160, 169, 19, 0x20, 0x80, 0x85, 0x21, 0x51, 0x17, 0x4, 0xf3, 0x40, 0x45, 0x4, 0x2, 0xf3, 0x80, 0x28, 0x28, 0x17, 0xec, 0x50,
  10, 9, 11, 0, 0, // 20ac Euro
  160, 172, 16, 0x3, 0x90, 0xc6, 0xef, 0x5c, 0xe3, 0xf1, 0x10, 0x13, 0xf1, 0x10, 0x1a, 0xb8, 0x31, 0x40, 0xee,
  9, 8, 11, 1, 0, // 20ad uni20AD
  160, 173, 14, 0x20, 0x88, 0x42, 0x20, 0x90, 0x28, 0x3f, 0x24, 0x8, 0x82, 0x10, 0x82, 0x20, 0x40,
  0xff]

/**
The characters from the Letterlike Symbols Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Letterlike_Symbols )
This block has 80 assigned code points, but only 6 of
  them are present in this font:
  degree Celcius,
  degree Fahrenheit,
  trademark,
  Kelvin sign,
  Angstrom sign, and
  turned capital F.
  This block contains characters in the range 0x2100-0x214f.
  The bitmaps for this block in this font take up about 332 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
LETTERLIKE_SYMBOLS ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0x4c, 0x1, 0x0, 0x0, // Length 332.
  0xf6, 0x14, 0x35, 0x19, 0xd5, 0x29, 0x35, 0xd, 0x46, 0xba, 0x63, 0x7c, 0x80, 0xff, 0x61, 0x35, 0xf9, 0xb0, 0xeb, 0xec, 0x15, 0x84, 0xb7, 0xed, 0x6a, 0xbf, 0x44, 0xef, 0xe4, 0x37, 0x2f, 0x8c, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x0, 0x21, 0x0, // Unicode range start 0x002100.
  116, 0x4f, 0x21, 0x0, // Unicode range end 0x00214f.
  0,
  16, 14, 11, 1, 0, // 2103 uni2103
  161, 3, 15, 0x18, 0x7, 0x2, 0x44, 0x8c, 0x7c, 0x18, 0xb8, 0x2, 0x8e, 0x80, 0x44, 0x8c, 0xe1, 0xc0,
  14, 13, 11, 1, 0, // 2109 uni2109
  161, 9, 12, 0x18, 0xcf, 0x82, 0x4b, 0x94, 0x62, 0x40, 0x26, 0x4f, 0xf, 0x7a, 0x34,
  13, 11, 6, 1, 4, // 2122 trademark
  161, 34, 8, 0x3e, 0x82, 0x0, 0x8f, 0x42, 0x22, 0x82, 0x20,
  9, 8, 11, 1, 0, // 212a uni212A
  161, 42, 13, 0x20, 0x88, 0x42, 0x20, 0x90, 0x28, 0x34, 0x90, 0x22, 0x8, 0x42, 0x8, 0x81,
  9, 9, 14, 0, 0, // 212b uni212B
  161, 43, 16, 0x3, 0x10, 0x49, 0x50, 0x31, 0x50, 0x51, 0x50, 0x89, 0x51, 0x5, 0x1f, 0xd1, 0x5, 0xba, 0xe5,
  8, 7, 11, 1, 0, // 2132 uni2132
  161, 50, 7, 0x0, 0xa0, 0x1f, 0x80, 0x25, 0x4f, 0xe0,
  0xff]

/**
The characters from the Mathematical Operators Unicode block in the sans_10 font.
  (See https://en.wikipedia.org/wiki/Mathematical_Operators )
This block has 256 assigned code points, but only 18 of
  them are present in this font.
  This block contains characters in the range 0x2200-0x22ff.
  The bitmaps for this block in this font take up about 498 bytes.
Deprecated.  Removed in favour of the font_x11_adobe package.
*/
MATHEMATICAL_OPERATORS ::= #[
  0x97, 0xf0, 0x17, 0x70, // Magic number 0x7017f097.
  0xf2, 0x1, 0x0, 0x0, // Length 498.
  0x11, 0x2d, 0xb1, 0xca, 0x3, 0x64, 0xd5, 0x9b, 0x1d, 0xc8, 0x14, 0xc9, 0x14, 0x6d, 0x9c, 0x7c, 0x7f, 0x5d, 0x72, 0xb4, 0x48, 0xa0, 0x6d, 0x70, 0x1d, 0x46, 0x88, 0xd3, 0xc6, 0x82, 0x5d, 0xe2, // Sha256 checksum.
  0x92, 's','a','n','s','_','1','0',0, // Font name "sans_10".
  0x9d, '"','C','o','p','y','r','i','g','h','t',' ','(','c',')',' ',
  '1','9','8','4',',',' ','1','9','8','7',' ','A','d','o','b','e',' ',
  'S','y','s','t','e','m','s',' ','I','n','c','o','r','p','o','r','a','t','e','d','.',' ',
  'A','l','l',' ','R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.',' ',
  'C','o','p','y','r','i','g','h','t',' ','(','c',')',' ','1','9','8','8',',',' ',
  '1','9','9','1',' ','D','i','g','i','t','a','l',' ','E','q','u','i','p','m','e','n','t',' ',
  'C','o','r','p','o','r','a','t','i','o','n','.',' ','A','l','l',' ',
  'R','i','g','h','t','s',' ','R','e','s','e','r','v','e','d','.','"',0, // Copyright message
  102, 0x0, 0x22, 0x0, // Unicode range start 0x002200.
  116, 0xff, 0x22, 0x0, // Unicode range end 0x0022ff.
  0,
  9, 9, 11, 0, 0, // 2200 universal
  162, 0, 14, 0xba, 0xe5, 0x10, 0x78, 0x7f, 0x44, 0x14, 0x22, 0x54, 0x14, 0x54, 0x1c, 0x7e, 0x40,
  9, 7, 11, 1, 0, // 2203 existential
  162, 3, 8, 0x3f, 0x80, 0x25, 0x47, 0xe0, 0x9, 0x53, 0xf8,
  9, 7, 11, 1, 0, // 2204 uni2204
  162, 4, 10, 0x3f, 0x80, 0x60, 0x29, 0x47, 0xe0, 0x49, 0x8, 0x93, 0xf8,
  9, 7, 1, 1, 4, // 2212 minus
  162, 18, 2, 0x3f, 0x80,
  3, 5, 10, 255, 0, // 2215 fraction
  162, 21, 5, 0x2, 0x1c, 0x71, 0xc7, 0x10,
  4, 2, 1, 1, 4, // 2219 periodcentered
  162, 25, 2, 0x30, 0x0,
  3, 1, 8, 1, 0, // 2236 uni2236
  162, 54, 4, 0xb9, 0xe5, 0x6e, 0x40,
  9, 6, 6, 1, 3, // 2259 uni2259
  162, 89, 6, 0x4, 0x2, 0x8e, 0x3f, 0x38, 0xfc,
  9, 6, 6, 1, 3, // 225a uni225A
  162, 90, 6, 0xa, 0x3e, 0xe3, 0xf3, 0x8f, 0xc0,
  9, 6, 11, 1, 255, // 2260 notequal
  162, 96, 9, 0x2, 0x1c, 0x4f, 0xc0, 0x80, 0xfc, 0x8, 0x31, 0x40,
  9, 6, 5, 0, 2, // 2261 equivalence
  162, 97, 5, 0x3f, 0x38, 0xfc, 0xe3, 0xf0,
  9, 6, 11, 0, 255, // 2262 uni2262
  162, 98, 10, 0x2, 0x1c, 0x3f, 0x1, 0x3, 0xf0, 0x20, 0x3f, 0x4, 0x5,
  8, 6, 7, 1, 0, // 2264 lessequal
  162, 100, 8, 0x3, 0x3, 0x3, 0x0, 0x30, 0x3, 0x38, 0xfc,
  8, 6, 7, 1, 0, // 2265 greaterequal
  162, 101, 8, 0x30, 0x3, 0x0, 0x30, 0x30, 0x30, 0x38, 0xfc,
  8, 6, 11, 1, 255, // 226e uni226E
  162, 110, 10, 0x2, 0x1c, 0x7, 0x3, 0x3, 0x80, 0x30, 0xb, 0x4, 0x5,
  8, 6, 11, 1, 255, // 226f uni226F
  162, 111, 10, 0x2, 0x1c, 0x34, 0x3, 0x0, 0xb0, 0x30, 0x38, 0x3e, 0x50,
  8, 6, 11, 1, 254, // 2270 uni2270
  162, 112, 12, 0x2, 0x1b, 0xc3, 0x3, 0x40, 0x30, 0xb, 0x2, 0x3, 0xf0, 0x40, 0x40,
  8, 6, 11, 1, 254, // 2271 uni2271
  162, 113, 12, 0x2, 0x13, 0x40, 0x30, 0x7, 0x3, 0x3, 0x80, 0x20, 0x3f, 0x4, 0x4,
  0xff]
